<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: banners.php 2012-01-28 19:10:21 (Iman92)$
 */

if (!defined('ADMIN_FILE')) {
	die ("Access Denied");
}

if (is_superadmin()):

$pars->input['positionID'] = (int) pn_getParam('positionID', $pars->input);
$pars->input['bannerID'] = (int) pn_getParam('bannerID', $pars->input);

function topmenu($Banners) {
	  OpenTable();
      echo '<center>[ '.html::a(adminLink('Banners'), 'بنر ها', $Banners=='Banners'? 'class=pars_active' : null).' - '.html::a(adminLink('Banners'), 'بنر جديد').' - '.html::a(adminLink('Positions'), 'موقعيت ها', $Banners=='Positions'? 'class=pars_active' : null).' ]</center>';
	  CloseTable();
}

function Positions() {
	  global $db, $admin_file, $pars, $cache, $op;
	  set_title("موقعيت هاي بنرها");
	  get_header();
	  GraphicAdmin();
	  title("موقعيت هاي بنرها");
      topmenu("Positions");
      if (!isset($cache->banners_positions) || !is_array($cache->banners_positions) || !count($cache->banners_positions)) {
          $cache->banners_positions = array();
          $result = $db->query("SELECT * FROM #__banners_positions order by position_id asc");
          while ($row = $db->fetchRow($result)) {
              $cache->banners_positions[ $row["position_id"] ] = $row;
          }
          $db->freeResult($result);
          unset($result, $row);
      }
      if ($op=="editPositions" && !isset($cache->banners_positions[$pars->input['positionID']]))
      pn_redirect( adminLink("Positions") );

	  OpenTable($op=="Positions"? "افزودن موقعيت" : "ويرايش موقعيت");
	  echo html::form("savePositions", "{$admin_file}.php");
      $t = new table(null, null, null, 5);

      $t->tr();
      $t->td( "عنوان موقعيت", "width: 100px" );
      $t->td( html::input("position_title", ($op=="editPositions"? $cache->banners_positions[$pars->input['positionID']]['position_title'] : ""), 'size="30"') );

      $t->tr();
      $t->td( "شناسه موقعيت");
      $t->td( html::input("position_name", ($op=="editPositions"? $cache->banners_positions[$pars->input['positionID']]['position_name'] : ""), 'size="30" dir="ltr"') . " فقط اعداد و حروف لاتين مجاز مي باشد." );

      $t->tr();
      $t->td();
      $t->td( html::hidden("op", $op=="Positions"? "savePositions" : "saveEditPositions") . html::hidden("positionID", $op=="Positions"? 0 : $pars->input['positionID']) . html::submit("submit", "ذخيره") );

      $t->show();
	  echo html::form("End");
	  CloseTable();


	  OpenTable("موقعيت هاي بنرها");
      $t = new table('pars_table', null, null, 5);

      $t->tr();
      $t->th( "ID", "width: 50px" );
      $t->th( "شناسه", "width: 100px" );
      $t->th( "عنوان" );
      $t->th( "عمليات", "width: 60px" );

	  foreach ($cache->banners_positions as $row) {
             $t->tr("class=".odd_even());
             $t->td( $row['position_id'] );
             $t->td( $row['position_name'], "text-align: center" );
             $t->td( $row['position_title'] );
             $t->td( html::a(adminLink("editPositions&positionID=".$row['position_id']), html::img("images/icon/page_edit.png"), "title='ويرايش'") .' '. html::a("javascript:pn_confirm('".adminLink('removePositions&positionID='.$row['position_id'])."')", html::img("images/icon/cross.png"), "title='حذف'"), "text-align:center" );
	  }

      $t->show();
	  CloseTable();
	  get_footer();
}

function savePositions($position_title, $position_name) {
	  global $db, $cache, $currentlang;
      $sql = array();
      $sql['position_title'] = pn_safe($position_title, "_nohtml");
      $sql['position_name'] = pn_safe($position_name, "_nohtml");

      if (empty($sql['position_title']) || empty($sql['position_name'])) {
           get_header();
           pn_error("نام و يا شناسه را وارد نكرده ايد!");
      }

      if (!preg_check("/^[0-9a-z-_ ]{1,100}$/i", $sql['position_name'])) {
           get_header();
           pn_error("شناسه داراي حروف غير مجاز مي باشد!");
      }

      $db->insert("banners_positions", $sql);
	  pn_redirect( adminLink("Positions") );
}

function saveEditPositions($position_id, $position_title, $position_name) {
	  global $db, $cache, $currentlang;
      $position_id = (int) $position_id;
      $sql = array();
      $sql['position_title'] = pn_safe($position_title, "_nohtml");
      $sql['position_name'] = pn_safe($position_name, "_nohtml");

      if (empty($sql['position_title']) || empty($sql['position_name'])) {
           get_header();
           pn_error("نام و يا شناسه را وارد نكرده ايد!");
      }

      if (!preg_check("/^[0-9a-z-_ ]{1,100}$/i", $sql['position_name'])) {
           get_header();
           pn_error("شناسه داراي حروف غير مجاز مي باشد!");
      }

      $db->update("banners_positions", $sql, "position_id='$position_id'", 1);
	  pn_redirect( adminLink("Positions") );
}

function removePositions($position_id) {
	  global $db, $cache, $op;
	  $position_id = (int) $position_id;
	  $db->query("DELETE FROM `#__banners_positions` WHERE `position_id`='$position_id' LIMIT 1");
	  pn_redirect( adminLink('Positions') );
}

function Banners() {
	  global $db, $admin_file, $pars, $cache, $op;
	  set_title("بنرها");
	  get_header();
	  GraphicAdmin();
	  title("بنرها");
      topmenu("Banners");
      if (!isset($cache->banners) || !is_array($cache->banners) || !count($cache->banners)) {
          $cache->banners = array();
          $result = $db->query("SELECT * FROM #__banners order by banner_id asc");
          while ($row = $db->fetchRow($result)) {
              $cache->banners[ $row["banner_id"] ] = $row;
          }
          $db->freeResult($result);
          unset($result, $row);
      }
      if (!isset($cache->banners_positions) || !is_array($cache->banners_positions) || !count($cache->banners_positions)) {
          $cache->banners_positions = array();
          $result = $db->query("SELECT * FROM #__banners_positions order by position_id asc");
          while ($row = $db->fetchRow($result)) {
              $cache->banners_positions[ $row["position_id"] ] = $row;
          }
          $db->freeResult($result);
          unset($result, $row);
      }
      if ($op=="editBanners" && !isset($cache->banners[$pars->input['bannerID']]))
      pn_redirect( adminLink("Banners") );

     set_head('<link rel="alternate stylesheet" type="text/css" media="all" href="includes/pars_nuke/javascript/jalalijscalendar/skins/calendar-black.css" title="black" />
<script type="text/javascript" src="includes/pars_nuke/javascript/jalalijscalendar/jalali.js"></script>
<script type="text/javascript" src="includes/pars_nuke/javascript/jalalijscalendar/calendar.js"></script>
<script type="text/javascript" src="includes/pars_nuke/javascript/jalalijscalendar/calendar-setup.js"></script>
<script type="text/javascript" src="includes/pars_nuke/javascript/jalalijscalendar/lang/calendar-fa.js"></script>');

	  OpenTable($op=="Banners"? "افزودن بنر" : "ويرايش بنر");
	  echo html::form("savePositions", "{$admin_file}.php");
      $t = new table(null, null, null, 5);

      $t->tr();
      $t->td( "عنوان بنر", "width: 100px" );
      $t->td( html::input("banner_title", ($op=="editBanners"? $cache->banners[$pars->input['bannerID']]['banner_title'] : ""), 'size="40"') );

      $options = array();
      foreach($cache->banners_positions as $position) {
          $options[$position['position_name']] = $position['position_title'];
      }
      $t->tr();
      $t->td( "موقعيت بنر" );
      $t->td( html::select('banner_position', $options, ($op=="editBanners"? $cache->banners[$pars->input['bannerID']]['banner_position'] : "")) );

      $options = array("1"=>"عكس", "2"=>"فلش", "3"=>"كد");
      $t->tr();
      $t->td( "نوع بنر" );
      $t->td( html::select('banner_type', $options, ($op=="editBanners"? $cache->banners[$pars->input['bannerID']]['banner_type'] : "1")) );

      $t->tr();
      $t->td( "فعال باشد بنر" );
      $t->td( html::radio("banner_active", array("1"=>_YES, "0"=>_NO), ($op=="editBanners"? $cache->banners[$pars->input['bannerID']]['banner_active'] : "1")) );

      if (is_superAdmin()) {
      $t->tr();
      $t->td();
      $t->td("<img src=\"images/icon/attach.png\" width=\"16\" height=\"16\"><a onclick=\"window.open('".adminLink("media&noTheme=true")."','media','toolbar=no,location=no,directories=no,status=no,scrollbars=no,resizable=no,copyhistory=no,width=800,height=430');\" class=\"pars_green\" title=\"كليك كنيد\">دسترسي سريع به مديريت رسانه ها</a>");
      }

      $t->tr();
      $t->td( "فايل بنر" );
      $t->td( html::input("banner_file", ($op=="editBanners"? $cache->banners[$pars->input['bannerID']]['banner_file'] : ""), 'size="40" dir="ltr"') );

      $t->tr();
      $t->td( "طول بنر" );
      $t->td( html::input("banner_width", ($op=="editBanners"? $cache->banners[$pars->input['bannerID']]['banner_width'] : "468"), 'size="4" dir="ltr"') );

      $t->tr();
      $t->td( "عرض بنر" );
      $t->td( html::input("banner_height", ($op=="editBanners"? $cache->banners[$pars->input['bannerID']]['banner_height'] : "60"), 'size="4" dir="ltr"') );

      $t->tr();
      $t->td( "آدرس لينك" );
      $t->td( html::input("banner_url", ($op=="editBanners"? $cache->banners[$pars->input['bannerID']]['banner_url'] : "http://"), 'size="40" dir="ltr"') );

      $t->tr();
      $t->td( "تعداد كليك ها" );
      $t->td( html::input("banner_clicks", ($op=="editBanners"? $cache->banners[$pars->input['bannerID']]['banner_clicks'] : "0"), 'size="4" dir="ltr"') );

      $t->tr();
      $t->td( "دفعات نمايش بنر" );
      $t->td( html::input("banner_hits", ($op=="editBanners"? $cache->banners[$pars->input['bannerID']]['banner_hits'] : "0"), 'size="4" dir="ltr"') );

      $t->tr();
      $t->td( "كد HTML" );
      $t->td( html::textarea("banner_code", ($op=="editBanners"? $cache->banners[$pars->input['bannerID']]['banner_code'] : ""), "70x8") . "<br>فقط براي زماني كه نوع كد انتخاب شده باشد، براي آدرس لينك بنر در كدهاي مي توانيد از تگ <b>{PN_ADS_URL}</b> استفاده كنيد." );

      $t->tr();
      $t->td( "زمان پايان نمايش" );
      $t->td( html::input("banner_date", jdate("Y-m-j H:i:s", strtotime(($op=="editBanners"? $cache->banners[$pars->input['bannerID']]['banner_date'] : date('Y-m-j H:i:s')))), 'size="21" dir="ltr" id="banner_date"') . '<img id="date_date_btn" src="images/icon/calendar_view_week.png" style="vertical-align:top;cursor:pointer;" />' );

      $t->tr();
      $t->td();
      $t->td( html::hidden("op", $op=="Banners"? "saveBanners" : "saveEditBanners") . html::hidden("bannerID", $op=="Banners"? 0 : $pars->input['bannerID']) . html::submit("submit", "ذخيره") );

      $t->show();
echo '<script type="text/javascript">
	  setActiveStyleSheet("black");
	  var popupCal = Calendar.setup({
		   inputField     : "banner_date", // id of the input field
		   button         : "date_date_btn", // trigger for the calendar (button ID)
		   ifFormat       : "%Y-%m-%d", // format of the input field
		   dateType	   : "jalali",
		   align          : "Bl", // alignment (defaults to "Bl")
		   weekNumbers    : true,
		   autoShowOnFocus: true
	  });
</script>';
	  echo html::form("End");
	  CloseTable();


	  OpenTable("بنرها");
      $t = new table('pars_table', null, null, 5);

      $t->tr();
      $t->th( "ID", "width: 50px" );
      $t->th( "موقعيت", "width: 100px" );
      $t->th( "عنوان" );
      $t->th( "وضعيت", "width: 60px" );
      $t->th( "نوع", "width: 50px" );
      $t->th( "تاريخ پايان نمايش", "width: 140px" );
      $t->th( "عمليات", "width: 60px" );

	  foreach ($cache->banners as $row) {
			 $active = ($row['banner_active']==0 || strtotime($row['banner_date']) <= time())? "<img src='images/icon/exclamation.png' title='غيرفعال' />" : "<img src='images/icon/accept.png' title='فعال' />";
	         switch($row['banner_type']) {
	            case'1':
                $banner_type = "عكس";
	            break;

	            case'2':
                $banner_type = "فلش";
	            break;

	            default:
                $banner_type = "كد";
	            break;
	         }
             $t->tr("class=".odd_even());
             $t->td( $row['banner_id'] );
             $t->td( $row['banner_position'], "text-align: center" );
             $t->td( $row['banner_title'].(strtotime($row['banner_date']) < time()? ' <b class=pars_red>تاريخ نمايش به پايان رسيده!</b>' : null) );
             $t->td( html::a(adminLink("activeBanners&bannerID=".$row['banner_id']), $active), "text-align: center" );
             $t->td( $banner_type, "text-align: center" );
             $t->td( jdate("Y-m-j H:i:s", strtotime($row['banner_date'])), "text-align: center" );
             $t->td( html::a(adminLink("editBanners&bannerID=".$row['banner_id']), html::img("images/icon/page_edit.png"), "title='ويرايش'") .' '. html::a("javascript:pn_confirm('".adminLink('removeBanners&bannerID='.$row['banner_id'])."')", html::img("images/icon/cross.png"), "title='حذف'"), "text-align:center" );
	  }

      $t->show();
	  CloseTable();
	  get_footer();
}

function saveBanners($banner_title, $banner_clicks, $banner_hits, $banner_type, $banner_active, $banner_date, $banner_position, $banner_code, $banner_width, $banner_height, $banner_file, $banner_url) {
	  global $db, $cache, $currentlang;
      $sql = array();
      $sql['banner_title'] = pn_safe($banner_title, "_nohtml");
      $sql['banner_clicks'] = (int) $banner_clicks;
      $sql['banner_hits'] = (int) $banner_hits;
      $sql['banner_type'] = (int) $banner_type;
      $sql['banner_active'] = (int) $banner_active;
      $sql['banner_date'] = pn_safe($banner_date, "_nohtml");
      $sql['banner_position'] = pn_safe($banner_position, "_nohtml");
      $sql['banner_code'] = $banner_code;
      $sql['banner_width'] = (int) $banner_width;
      $sql['banner_height'] = (int) $banner_height;
      $sql['banner_file'] = pn_safe($banner_file, "_nohtml");
      $sql['banner_url'] = pn_safe($banner_url, "_nohtml");

      if (empty($sql['banner_title']) || empty($sql['banner_date']) || empty($sql['banner_file']) || empty($sql['banner_url'])) {
           get_header();
           pn_error("اطلاعات ناقص است!");
      }

      $date = explode(" ", $sql['banner_date']);
      $date[0] = explode("-", $date[0]);
      $year = $date[0][0];
      $month = $date[0][1];
      $dbay = $date[0][2];
      list($year, $month, $dbay) = jalali_to_gregorian($year, $month, $dbay);
      $sql['banner_date'] = "$year-$month-$dbay $date[1]";

      $db->insert("banners", $sql);
	  pn_redirect( adminLink("Banners") );
}

function saveEditBanners($bannerID, $banner_title, $banner_clicks, $banner_hits, $banner_type, $banner_active, $banner_date, $banner_position, $banner_code, $banner_width, $banner_height, $banner_file, $banner_url) {
	  global $db, $cache, $currentlang;
      $bannerID = (int) $bannerID;
      $sql = array();
      $sql['banner_title'] = pn_safe($banner_title, "_nohtml");
      $sql['banner_clicks'] = (int) $banner_clicks;
      $sql['banner_hits'] = (int) $banner_hits;
      $sql['banner_type'] = (int) $banner_type;
      $sql['banner_active'] = (int) $banner_active;
      $sql['banner_date'] = pn_safe($banner_date, "_nohtml");
      $sql['banner_position'] = pn_safe($banner_position, "_nohtml");
      $sql['banner_code'] = $banner_code;
      $sql['banner_width'] = (int) $banner_width;
      $sql['banner_height'] = (int) $banner_height;
      $sql['banner_file'] = pn_safe($banner_file, "_nohtml");
      $sql['banner_url'] = pn_safe($banner_url, "_nohtml");

      if (empty($sql['banner_title']) || empty($sql['banner_date']) || empty($sql['banner_file']) || empty($sql['banner_url'])) {
           get_header();
           pn_error("اطلاعات ناقص است!");
      }

      $date = explode(" ", $sql['banner_date']);
      $date[0] = explode("-", $date[0]);
      $year = $date[0][0];
      $month = $date[0][1];
      $dbay = $date[0][2];
      list($year, $month, $dbay) = jalali_to_gregorian($year, $month, $dbay);
      $sql['banner_date'] = "$year-$month-$dbay $date[1]";

      $db->update("banners", $sql, "banner_id='$bannerID'", 1);
	  pn_redirect( adminLink("editBanners&bannerID=".$bannerID) );
}

function removeBanners($banner_id) {
	  global $db, $cache, $op;
	  $banner_id = (int) $banner_id;
	  $db->query("DELETE FROM `#__banners` WHERE `banner_id`='$banner_id' LIMIT 1");
	  pn_redirect( adminLink('Banners') );
}

function activeBanners($bannerID) {
	  global $prefix, $db, $admin_file;
	  $bannerID = intval($bannerID);
	  $row = $db->fetchRowSet("select banner_active from #__banners where banner_id='$bannerID'");
	  $active = intval($row['banner_active']);
	  if ($active == 0) {
			$active = 1;
	  } elseif ($active == 1) {
			$active = 0;
	  }
	  $db->query("update #__banners set banner_active='$active' where banner_id='$bannerID'");
	  pn_redirect( adminLink("Banners") );
}

switch($op):

   case'Positions':
   case'editPositions':
   Positions();
   break;

   case'savePositions':
   savePositions($pars->input['position_title'], $pars->input['position_name']);
   break;

   case'saveEditPositions':
   saveEditPositions($pars->input['positionID'], $pars->input['position_title'], $pars->input['position_name']);
   break;

   case'removePositions':
   removePositions($pars->input['positionID']);
   break;

   case'Banners':
   case'editBanners':
   Banners();
   break;

   case'saveBanners':
   saveBanners($pars->input['banner_title'], $pars->input['banner_clicks'], $pars->input['banner_hits'], $pars->input['banner_type'], $pars->input['banner_active'], $pars->input['banner_date'], $pars->input['banner_position'], $pars->input['banner_code'], $pars->input['banner_width'], $pars->input['banner_height'], $pars->input['banner_file'], $pars->input['banner_url']);
   break;

   case'saveEditBanners':
   saveEditBanners($pars->input['bannerID'], $pars->input['banner_title'], $pars->input['banner_clicks'], $pars->input['banner_hits'], $pars->input['banner_type'], $pars->input['banner_active'], $pars->input['banner_date'], $pars->input['banner_position'], $pars->input['banner_code'], $pars->input['banner_width'], $pars->input['banner_height'], $pars->input['banner_file'], $pars->input['banner_url']);
   break;

   case'activeBanners':
   activeBanners($pars->input['bannerID']);
   break;

   case'removeBanners':
   removeBanners($pars->input['bannerID']);
   break;

endswitch;

else:

     get_header();
     pn_error("شما به اين بخش دسترسي نداريد!، لطفا تلاش نكنيد.", "عدم دسترسي");

endif;
?>