<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: class_firewall.php 2012-01-28 18:01:16 (Iman92)$
 */

if (stristr(htmlentities($_SERVER['PHP_SELF']), "class_firewall.php")) {
	Header("Location: ../index.php");
	die();
}

class firewall {
	private $QUERY_STRING = null;
	private $REQUEST_URI = null;
	private $IP = null;
	private $Hacking_attempt = 0;
	private $Hacking_type = 2;

	public function __construct($class=null, $id=null, $style=null, $cellpadding=0, $cellspacing=0, $extra=null) {
		$this->QUERY_STRING = addslashes(str_replace( "\\", "/", html_entity_decode( urldecode( $_SERVER['QUERY_STRING'] ) ) ));
		$this->REQUEST_URI = addslashes(str_replace( "\\", "/", html_entity_decode( urldecode( $_SERVER['REQUEST_URI'] ) ) ));
		$this->IP = addslashes(get_ip());
	}

	public function check() {
		$this->check_xss();
		$this->check_cookie();
        if (!is_admin())
		$this->postString();
        if ($this->Hacking_attempt >= 1) {
                global $pars, $db;
                $pars->settings['firewall'] = (int) $pars->settings['firewall'];
                $pars->settings['block_ip'] = (int) $pars->settings['block_ip'];
	            $db->query("UPDATE `#__settings` SET `setting_value`=`setting_value`+1 where setting_name='firewall_count' limit 1");
                if ($pars->settings['firewall'] != 0) {
                      $sql = array();
                      $sql['time'] = date("Y-m-d H:i:s");
                      $sql['ip'] = $this->IP;
                      $sql['url'] = $this->REQUEST_URI;
                      $sql['post'] = $this->join($_POST);
                      $sql['get'] = $this->join($_GET);
                      $sql['files'] = $this->join($_FILES);
                      $sql['cookie'] = $this->join($_COOKIE);
                      $db->insert("firewall", $sql);
                }
                if ($pars->settings['block_ip'] != 0 && !is_admin() && $this->Hacking_type > 1) {
                      $sql = array();
                      $sql['ip_address'] = $this->IP;
                      $sql['date'] = date("Y-m-d H:i:s");
                      $sql['reason'] = "آي پي شما به دليل تلاش براي هك كردن سايت به صورت خودكار توسط سيستم امنيتي مسدود شده است.";
                      $db->insert("banned_ip", $sql);
	                  $db->query("UPDATE `#__settings` SET `setting_value`=`setting_value`+1 where setting_name='firewall_bannedIP_count' limit 1");
                }
                echo "<html>\n";
                echo "<head>\n";
                echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n";
                echo "<title>ParsNuke > Hacking attempt!</title>\n";
                echo "</head>\n";
                echo "<body bgcolor=\"Black\" style=\"font-family:arial; color:#ffffff; cursor:default;\">\n";
                echo "<table width=\"100%\" height=\"100%\"><tr><td align=\"center\" valign=\"center\">\n";
                echo "<img src=\"images/powered/powered3.jpg\"><br><br>\n";
                echo "<span style=\"font-size:24px; font-weight:bold;\">Hacking attempt!</span><br>\n";
                if ($pars->settings['block_ip'] != 0 && $this->Hacking_type > 1)
                echo "<span style=\"font-size:12px; font-weight:bold;\">You have been banned by the system!</span><br>\n";
                echo "<span style=\"font-size:12px; font-weight:bold;\">IP: ".$this->IP."</span><br>\n";
                echo "<center><a style=\"font-size:11px; font-weight:bold; text-decoration:none; color:f9f9f9;\" href=\"http://ParsNuke.com\" onmouseover=this.style.color='#cccccc' onmouseout=this.style.color='#f6f6f6'>ParsNuke.com</a></center>\n";
                echo "</td></tr></table>\n";
                echo "</body>\n";
                echo "</html>";
                die;
        }
	}

	public function join($array) {
        $String = "";
        if (is_array($array) && count($array))
        foreach ($array as $key => $value) {
            if ($String > "") {
             $String .= "&".$key."=".$value;
            } else {
             $String .= $key."=".$value;
            }
        }
        return $String;
	}

	public function check_xss() {
		if( $this->QUERY_STRING ) {
		     if( (strpos( $this->QUERY_STRING, '<' ) !== false) || (strpos( $this->QUERY_STRING, '>' ) !== false) || (strpos( $this->QUERY_STRING, '"' ) !== false) || (strpos( $this->QUERY_STRING, './' ) !== false) || (strpos( $this->QUERY_STRING, '../' ) !== false) || (strpos( $this->QUERY_STRING, '\'' ) !== false) || (strpos( $this->QUERY_STRING, '.php' ) !== false) || (strpos( $this->QUERY_STRING, '*/union/*' ) !== false) || (strpos( $this->QUERY_STRING, ' union ' ) !== false) || (strpos( $this->QUERY_STRING, '+union+' ) !== false) || (strpos( $this->QUERY_STRING, 'document.cookie' ) !== false)) {
		         $this->Hacking_attempt++;
		         $this->Hacking_type = 1;
		     }
		}

		if( $this->REQUEST_URI ) {
		     if( (strpos( $this->REQUEST_URI, '<' ) !== false) || (strpos( $this->REQUEST_URI, '>' ) !== false) || (strpos( $this->REQUEST_URI, '"' ) !== false) || (strpos( $this->REQUEST_URI, '\'' ) !== false) || (strpos( $this->QUERY_STRING, '*/union/*' ) !== false) || (strpos( $this->QUERY_STRING, ' union ' ) !== false) || (strpos( $this->QUERY_STRING, '+union+' ) !== false) || (strpos( $this->QUERY_STRING, 'document.cookie' ) !== false) ) {
		         $this->Hacking_type = 1;
		     }
		}
	}

	public function check_cookie() {
        global $admin, $member, $loginKey;
		// This block of code makes sure $admin and $member and $loginKey are COOKIES
		if((isset($admin) && $admin != $_COOKIE['admin']) OR  (isset($member) && $member != $_COOKIE['member']) OR (isset($loginKey) && $loginKey != $_COOKIE['loginKey']) OR (isset($adminKey) && $adminKey != $_COOKIE['adminKey'])) {
		      $this->Hacking_attempt++;
		      $this->Hacking_type = 2;
		}
	}

	public function postString() {
        global $admin, $loc, $matches;
        $postString = $this->join($_POST);
        $postString = str_replace("%09", "%20", $postString);
        $postString_64 = base64_decode($postString);
        if ((stristr($postString,'%20union%20')) OR (stristr($postString,'*/union/*')) OR (stristr($postString,' union ')) OR (stristr($postString_64,'%20union%20')) OR (stristr($postString_64,'*/union/*')) OR (stristr($postString_64,' union ')) OR (stristr($postString_64,'+union+')) OR (stristr($postString,'http-equiv')) OR (stristr($postString_64,'http-equiv')) OR (stristr($postString,'alert(')) OR (stristr($postString_64,'alert(')) OR (stristr($postString,'javascript:')) OR (stristr($postString_64,'javascript:')) OR (stristr($postString,'document.cookie')) OR (stristr($postString_64,'document.cookie')) OR (stristr($postString,'onmouseover=')) OR (stristr($postString_64,'onmouseover=')) OR (stristr($postString,'document.location')) OR (stristr($postString_64,'document.location')))
        {
		      $this->Hacking_attempt++;
		      $this->Hacking_type = 2;
        }

        // Additional security (Union, CLike, XSS)
        //Union Tap
        //Copyright Zhen-Xjell 2004 http://nukecops.com
        //Beta 3 Code to prevent UNION SQL Injections
        unset($loc, $matches);
        if(isset($_SERVER['QUERY_STRING'])) {
            if (preg_match("/([OdWo5NIbpuU4V2iJT0n]{5}) /", rawurldecode($loc=$this->QUERY_STRING), $matches))
            {
		         $this->Hacking_attempt++;
		         $this->Hacking_type = 2;
            }
        }
        $queryString = $this->QUERY_STRING;
        if (($_SERVER['PHP_SELF'] != "/index.php") OR !isset($url))
        {
        	    if (stristr($queryString,'http://'))
		        $this->Hacking_attempt++;
		        $this->Hacking_type = 2;
        }
        if ((stristr($queryString,'%20union%20')) OR (stristr($queryString,'/*')) OR (stristr($queryString,'*/union/*')) OR (stristr($queryString,'c2nyaxb0')) OR (stristr($queryString,'+union+'))  OR ((stristr($queryString,'cmd=')) AND (!stristr($queryString,'&cmd'))) OR ((stristr($queryString,'exec')) AND (!stristr($queryString,'execu'))) OR (stristr($queryString,'concat')))
        {
		         $this->Hacking_attempt++;
		         $this->Hacking_type = 2;
        }
	}

	public function escapeString($array) {
		global $db;
		if(is_array($array) && Count($array))
		{
		     foreach($array as $key => $val)
		     {
		          if(is_array($val) && count($val))
		          {
                       $array[$key] = $this->escapeString($val);
		          }
		          else
		          {
                       $array[$key] = $db->escapeString($val);
		          }
		     }
		}
        return $array;
	}

	public function escapeString_vars() {
		$_REQUEST = isset($_REQUEST)? $this->escapeString($_REQUEST) : array();
		$_GET     = isset($_GET)? $this->escapeString($_GET) : array();
		$_POST    = isset($_POST)? $this->escapeString($_POST) : array();
		$_COOKIE  = isset($_COOKIE)? $this->escapeString($_COOKIE) : array();
	}

}

?>