<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: class_htaccess.php 2012-01-28 19:10:21 (Iman92)$
 */

if (stristr(htmlentities($_SERVER['PHP_SELF']), "class_htaccess.php")) {
	Header("Location: ../index.php");
	die();
}

class htaccess {
	public $module = null;
	public $code = null;
	public $htaccess = null;

	public function __construct($module=null, $code=null) {
		$this->module = pn_safe($module, "en-num");
		$this->code = $code;
		$this->htaccess = file_get_contents(INCLUDE_PATH.".htaccess");
	}

	public function update() {
		if (!is_superAdmin() || !is_writeable(INCLUDE_PATH.".htaccess") || empty($this->htaccess)) return -1;
		return file_put_contents(INCLUDE_PATH.".htaccess", trim($this->htaccess));
	}

	public function compact() {
		$this->htaccess = str_replace("\r", "\n", $this->htaccess);
		$this->htaccess = str_replace("\n\n\n\n", "\n", $this->htaccess);
		$this->htaccess = str_replace("\n\n\n", "\n", $this->htaccess);
		$this->htaccess = str_replace("\n\n", "\n", $this->htaccess);
		$this->htaccess = str_replace("############ Start", "\n############ Start", $this->htaccess);
		$this->htaccess = str_replace("#PARSNUKE.COM HTACCESS!", "\n#PARSNUKE.COM HTACCESS!", $this->htaccess);
	}

	public function add() {
	    $module = empty($module)? pn_safe($this->module, "en-num") : pn_safe($module, "en-num");
	    if (!is_superAdmin() || !is_writeable(INCLUDE_PATH.".htaccess") || empty($this->code) || empty($module)) return -1;
	    if (!stripos($this->htaccess, "############ Start ".$this->module." Module")) {
	         $this->code = "############ Start ".$this->module." Module\n".$this->code."\n############ End ".$this->module." Module\n\n";
	         $this->compact();
	         $this->htaccess = str_replace("#PARSNUKE.COM HTACCESS!", $this->code."#PARSNUKE.COM HTACCESS!", $this->htaccess);
	         return $this->update();
	    } else {
	         return false;
	    }
	}

	public function edit($module=null) {
	        if (!is_superAdmin() || !is_writeable(INCLUDE_PATH.".htaccess") || empty($this->code)) return -1;
	        $module = empty($module)? pn_safe($this->module, "en-num") : pn_safe($module, "en-num");
	        $count = preg_match_all("/############ Start ".$module." Module(.*)############ End ".$module." Module/msUi", $this->htaccess, $matches);
	        if ($count) {
                        for($o=0; $o<$count; $o++) {
                                if (!empty($matches[0][$o]))
                                {
                                        $this->code = "############ Start ".$module." Module\n".$this->code."\n############ End ".$module." Module\n\n";
                                        $this->htaccess = str_replace($matches[0][$o], $this->code, $this->htaccess);
                                        $this->compact();
                                        return $this->update();                         
                                }
                                else
                                {
                                        return false;
                                }
                        }
                        return false;
	        }
	}

	public function remove($module=null) {
	    $module = empty($module)? pn_safe($this->module, "en-num") : pn_safe($module, "en-num");
	    if (!is_superAdmin() || !is_writeable(INCLUDE_PATH.".htaccess") || empty($module)) return -1;
	    $count = preg_match_all("/############ Start ".$module." Module(.*)############ End ".$module." Module/msUi", $this->htaccess, $matches);
	    if ($count) {
                  for($o=0; $o<$count; $o++) {
                        if (!empty($matches[0][$o]))
                        {
                                $this->htaccess = str_replace($matches[0][$o], "", $this->htaccess);
                                $this->compact();
                                return $this->update();
                        }
                        else
                        {
                                return false;
                        }
                  }
	    }
	    return false;
	}

	public function get_code($module=null) {
		$module = empty($module)? pn_safe($this->module, "en-num") : pn_safe($module, "en-num");
		if (!is_superAdmin() || !is_writeable(INCLUDE_PATH.".htaccess") || empty($module)) return -1;
		$count = preg_match_all("/############ Start ".$module." Module(.*)############ End ".$module." Module/msUi", $this->htaccess, $matches);
		if ($count) {
                        for($o=0; $o<$count; $o++) {
                                if (!empty($matches[0][$o]))
                                {
                                        return trim($matches[1][$o]);
                                }
                                else
                                {
                                        return false;
                                }
                        }
		}
		return false;
	}
}

?>