<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: class_html.php 2012-01-28 18:01:16 (Iman92)$
 */

if (stristr(htmlentities($_SERVER['PHP_SELF']), "class_html.php")) {
	Header("Location: ../index.php");
	die();
}

class html {
    static function select($name, $options, $selected=null, $style=null) {
         $style = !empty($style)? " ".$style : null;
         $html = "<select name=\"$name\" size=\"1\"$style>";
         if(is_array($options) && count($options))
         foreach($options as $key => $val) {
              $html .= "<option value=\"$key\"".($key==$selected? " selected=\"selected\"" : null).">$val</option>";
         }
         $html .= "</select>";
         return $html;
    }

    static function radio($name, $options, $selected=null, $style=null) {
         $html = null;
         $style = !empty($style)? " ".$style : null;
         if(is_array($options) && count($options))
         foreach($options as $key => $val) {
              $html .= "<label><input type=\"radio\" name=\"{$name}\" value=\"{$key}\"".($key==$selected? " checked=\"checked\"" : null)."{$style}>{$val}</label> ";
         }
         return $html;
    }

    static function checkbox($options, $selected=null, $style=null) {
         $html = null;
         $style = !empty($style)? " ".$style : null;
         if(is_array($options) && count($options))
         foreach($options as $key => $val) {
              $key = explode("|", $key);
              $name = $key[0];
              $key = $key[1];
              $html .= "<label><input type=\"checkbox\" name=\"{$name}\" value=\"{$key}\"".($key==$selected? " checked=\"checked\"" : null)."{$style}>{$val}</label> ";
         }
         return $html;
    }

    static function hidden($name, $value) {
         return "<input name=\"{$name}\" type=\"hidden\" value=\"{$value}\">";
    }

    static function input($name, $value, $style=null) {
         $style = !empty($style)? " ".$style : null;
         return "<input name=\"{$name}\" type=\"text\" value=\"{$value}\"{$style}>";
    }

    static function submit($name, $value, $style=null) {
         $style = !empty($style)? " ".$style : null;
         return "<input name=\"{$name}\" type=\"submit\" value=\"{$value}\"{$style}>";
    }

    static function textarea($name, $value, $size=null, $style=null) {
         $style = !empty($style)? " ".$style : null;
         if (!empty($size)) {
               $size = explode("x", $size);
               $size = " rows=\"{$size[1]}\" cols=\"{$size[0]}\"";
         }
         return "<textarea name=\"{$name}\"{$size}{$style}>{$value}</textarea>";
    }

    static function js($code, $type="code") {
          if ($type=="code") {
               $html  = "<script language=\"JavaScript\" type=\"text/javascript\">\n";
               $html .= "<!--\n";
               $html .= $code;
               $html .= "\n//-->\n";
               $html .= "</script>";
          } else {
               $html = "<script type=\"text/javascript\" src=\"{$code}\"></script>";
          }
          return $html;
    }

    static function css($code, $type="code") {
          if ($type=="code") {
               $html  = "<style type=\"text/css\" media=\"screen\">\n";
               $html .= "<!--\n";
               $html .= $code;
               $html .= "\n//-->\n";
               $html .= "</style>";
          } else {
               $html = "<link href=\"{$code}\" type=\"text/css\" rel=\"stylesheet\" />";
          }
          return $html;
    }

    static function img($src, $extra=null) {
         $extra = !empty($extra)? " ".$extra : null;
         return "<img src=\"$src\"{$extra}>";
    }

    static function a($href, $text, $extra=null, $target=null) {
         $extra = !empty($extra)? " ".$extra : null;
         $target = !empty($target)? " target=\"{$target}\"" : null;
         return "<a href=\"$href\"{$target}{$extra}>{$text}</a>";
    }

    static function form($name, $action="index.php", $method="POST", $enctype=null, $style=null, $id=null, $line="\n") {
         if ($name=="End") return "</form>".$line;
         $style = !empty($style)? " style=\"{$style}\"" : null;
         $enctype = !empty($enctype)? " enctype=\"{$target}\"" : null;
         $id = !empty($id)? " {$id}" : null;
         return "<form name=\"{$name}\" id=\"form-{$name}{$id}\" action=\"{$action}\" method=\"{$method}\"{$enctype}{$style}>".$line;
    }

    static function a_button($link, $title, $image) {
         return html::a($link, html::img($image).$title, "class='pars_button'");
    }
}


class table {
	public $class, $style, $id, $cellpadding, $cellspacing, $extra;
	public $tr_count = 0;
	public $tr_att = null;
	public $td = array();
	public $th = array();

	public function __construct($class=null, $id=null, $style=null, $cellpadding=0, $cellspacing=0, $extra=null) {
		$this->class = $class;
		$this->id = $id;
		$this->style = $style;
		$this->cellpadding = $cellpadding;
		$this->cellspacing = $cellspacing;
		$this->extra = $extra;
	}

	public function att($name, $value) {
		return (!empty($value)? ' '.$name.'="'.$value.'"' : '');
	}

	public function tr($extra=null) {
		$this->tr_count++;
		$this->tr_att[$this->tr_count]['extra'] = $extra;
	}

	public function th($value=null, $style=null, $extra=null) {
		$c = count(isset($this->th[$this->tr_count])? $this->th[$this->tr_count] : array());
		$this->th[$this->tr_count][$c]['style'] = $style;
		$this->th[$this->tr_count][$c]['extra'] = $extra;
		$this->th[$this->tr_count][$c]['value'] = $value;
	}

	public function td($value=null, $style=null, $extra=null) {
		$c = count(isset($this->td[$this->tr_count])? $this->td[$this->tr_count] : array());
		$this->td[$this->tr_count][$c]['style'] = $style;
		$this->td[$this->tr_count][$c]['extra'] = $extra;
		$this->td[$this->tr_count][$c]['value'] = $value;
	}

	public function get_contents() {
		$start = 1;
		$show = null;
		$show .= "<table".$this->att('class', $this->class).$this->att('id', $this->id).$this->att('style', $this->style)." cellpadding=\"$this->cellpadding\" cellspacing=\"$this->cellspacing\"$this->extra>\n";

		if (isset($this->th[1]) && count($this->th[1])) {
		$show .= "<thead>\n";
		$show .= "<tr".(empty($this->tr_att[1]['extra'])? "" : " ".$this->tr_att[1]['extra']).">\n";
		for ($z=0; $z<=count($this->th[1])-1; $z++) {
			$show .= "\t<th".$this->att('style', $this->th[1][$z]['style']).(empty($this->th[1][$z]['extra'])? "" : " ".$this->th[1][$z]['extra']).">";
			$show .= trim($this->th[1][$z]['value']);
			$show .= "</th>\n";
		}
		$show .= "</tr>\n";
		$show .= "</thead>\n";
		$start = 2;
		}

		$show .= "<tbody>\n";
		for ($i=$start; $i<=$this->tr_count; $i++) {
			$show .= "<tr".(empty($this->tr_att[$i]['extra'])? "" : " ".$this->tr_att[$i]['extra']).">\n";
			for ($a=0; $a<=count($this->td[$i])-1; $a++) {
			     $show .= "\t<td".$this->att('style', $this->td[$i][$a]['style']).(empty($this->td[$i][$a]['extra'])? "" : " ".$this->td[$i][$a]['extra']).">";
			     $show .= trim($this->td[$i][$a]['value']);
			     $show .= "</td>\n";
			}
			$show .= "</tr>\n";
		}
		$show .= "</tbody>\n";
		$show .= "</table>\n";
		unset($this->tr_count, $this->td, $this->tr_att, $this->th, $start);
		return $show;
	}

	public function show() {
		echo $this->get_contents();
	}
}

?>