<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: class_mysql.php 2012-01-28 18:01:16 (Iman92)$
 */

if (stristr(htmlentities($_SERVER['PHP_SELF']), "class_mysql.php")) {
	Header("Location: ../index.php");
	die();
}

if(!defined("SQL_LAYER"))
define("SQL_LAYER","mysql");

class sql_db
{
	var $db_connect_id;
	var $query_result;
	var $row = array();
	var $rowset = array();
	var $prefix = null;
	var $num_queries = 0;
	var $query_time = 0;
	var $error_reporting = true;

	function sql_db($sqlserver, $sqluser, $sqlpassword, $database, $prefix, $persistency = true)
	{
		$this->persistency = $persistency;
		$this->user = $sqluser;
		$this->password = $sqlpassword;
		$this->server = $sqlserver;
		$this->dbname = $database;
		$this->prefix = $prefix . '_';

		if($this->persistency)
		{
			$this->db_connect_id = @mysql_pconnect($this->server, $this->user, $this->password);
		}
		else
		{
			$this->db_connect_id = @mysql_connect($this->server, $this->user, $this->password);
		}
		if($this->db_connect_id)
		{
			if($database != "")
			{
				$this->dbname = $database;
				$dbselect = @mysql_select_db($this->dbname);
				if(!$dbselect)
				{
					@mysql_close($this->db_connect_id);
					$this->db_connect_id = $dbselect;
				}
				if($this->db_connect_id)
				{
					@mysql_query("SET CHARACTER SET utf8;", $this->db_connect_id);
					@mysql_query("SET SESSION collation_connection='utf8_general_ci'", $this->db_connect_id);
				}
			}
			return $this->db_connect_id;
		}
		else
		{
			return false;
		}
	}

	protected function replace_prefix($sql, $prefix='#__') {
		$done = null;
		$single = false;
		$double = false;
		$found = false;
		$i = 0;
		while (strlen($sql) > 0) {
		if ($sql[$i] == null) return $done.$sql;
			if (($sql[$i] == "'") && $sql[$i-1] !="\\")
				$single = !$single;
			if (($sql[$i] == '"') && $sql[$i-1] !="\\")
				$double = !$double;

			if ($sql[$i] == $prefix[0] && !$single && !$double) {
				$found = true;
				for ($j=0; $j < strlen($prefix); $j++) {
					if ($sql[$i+$j] != $prefix[$j]) {
						$found = false;
						break;
					}
				}
			}

			if ($found) {
				$done .= substr($sql, 0, $i).$this->prefix;
				$sql = substr($sql, $i+$j);
				$found = false;
				$i = 0;
			}
			else
				$i++;
			if ($i >= strlen($sql)) return $done.$sql;
		}
		return $done;
	}

	function query($string="", $hide_errors=FALSE)
	{
		// Remove any pre-existing queries
		unset($this->query_result);
		if($string != "")
        {
		    $this->get_execution_time();
			$this->query_result = @mysql_query($this->replace_prefix($string, '#__'), $this->db_connect_id);
		    if($this->error_number() && !$hide_errors)
		    {
			     $this->error($string);
			     #exit;
		    }
		    $query_time = $this->get_execution_time();
		    $this->query_time += $query_time;
            $this->num_queries++;
		}

		if($this->query_result)
		{
			unset($this->row[''.$this->query_result.'']);
			unset($this->rowset[''.$this->query_result.'']);
			return $this->query_result;
		}
		return false;
	}

	function simple_select($table, $fields="*", $conditions="", $options=array())
	{
		$query = "SELECT ".$fields." FROM {$this->prefix}{$table}";
		if($conditions != "")
		{
			$query .= " WHERE ".$conditions;
		}
		if(isset($options['order_by']))
		{
			$query .= " ORDER BY ".$options['order_by'];
			if(isset($options['order_dir']))
			{
				$query .= " ".strtoupper($options['order_dir']);
			}
		}
		if(isset($options['limit_start']) && isset($options['limit']))
		{
			$query .= " LIMIT ".$options['limit_start'].", ".$options['limit'];
		}
		elseif(isset($options['limit']))
		{
			$query .= " LIMIT ".$options['limit'];
		}
		return $this->query($query);
	}

	function insert($table, $array) {
		if(!is_array($array))
		{
			return false;
		}
		$fields = "`".implode("`,`", array_keys($array))."`";
		$values = implode("','", $array);
		$this->query("
			INSERT
			INTO {$this->prefix}{$table} (".$fields.")
			VALUES ('".$values."')
		");
		return $this->insertID();
	}

	function update($table, $array, $where='', $limit='', $no_quote=false) {
		if(!is_array($array))
		{
			return false;
		}

		$comma = "";
		$query = "";
		$quote = "'";

		if($no_quote == true)
		{
			$quote = "";
		}

		foreach($array as $field => $value)
		{
			$query .= $comma."`".$field."`={$quote}{$value}{$quote}";
			$comma = ', ';
		}

		if(!empty($where))
		{
			$query .= " WHERE $where";
		}

		if(!empty($limit))
		{
			$query .= " LIMIT $limit";
		}

		return $this->query("
			UPDATE {$this->prefix}$table
			SET $query
		");
	}

	function delete($table, $where="", $limit="") {
		$query = "";
		if(!empty($where))
		{
			$query .= " WHERE $where";
		}

		if(!empty($limit))
		{
			$query .= " LIMIT $limit";
		}

		return $this->query("
			DELETE
			FROM {$this->prefix}$table
			$query
		");
	}

	function fetchArray($query_id=0, $set_query=0) {
		if(!$query_id)
		{
			$query_id = $this->query_result;
		}
		if($set_query)
		{
			$query_id = $this->query($query_id);
		}
		if($query_id)
		{
			$this->row[''.$query_id.''] = @mysql_fetch_array($query_id);
			return $this->row[''.$query_id.''];
		}
		else
		{
			return false;
		}
	}

	function fetchRow($query_id=0, $set_query=0)
	{
		if(!$query_id)
		{
			$query_id = $this->query_result;
		}
		if($set_query)
		{
			$query_id = $this->query($query_id);
		}
		if($query_id)
		{
			#$this->row[''.$query_id.''] = @mysql_fetch_array($query_id);
			$this->row[''.$query_id.''] = @mysql_fetch_assoc($query_id);
			return $this->row[''.$query_id.''];
		}
		else
		{
			return false;
		}
	}

	function fetchRowSet($query_id, $multi=false) {
	    if($multi)
        {
	        $d = array();
      	    $query_id = $this->query($query_id);
	        while($row = $this->fetchRow($query_id))
            $d[] = $row;
	    }
        else
        {
      	    $query_id = $this->query($query_id);
		    $d = $this->fetchRow($query_id);
	    }
        $this->freeResult();
		return $d;
	}

	function numRows($query_id=0, $set_query=false)
	{
		if(!$query_id)
		{
			$query_id = $this->query_result;
		}
		if($set_query)
		{
			$query_id = $this->query($query_id);
		}
		if($query_id)
		{
			$result = @mysql_num_rows($query_id);
			return $result;
		}
		else
		{
			return false;
		}
	}

	function affectedRows()
	{
		if($this->db_connect_id)
		{
			$result = @mysql_affected_rows($this->db_connect_id);
			return $result;
		}
		else
		{
			return false;
		}
	}

	function numFields($query_id=0)
	{
		if(!$query_id)
		{
			$query_id = $this->query_result;
		}
		if($query_id)
		{
			$result = @mysql_num_fields($query_id);
			return $result;
		}
		else
		{
			return false;
		}
	}

	function fieldName($offset, $query_id=0)
	{
		if(!$query_id)
		{
			$query_id = $this->query_result;
		}
		if($query_id)
		{
			$result = @mysql_field_name($query_id, $offset);
			return $result;
		}
		else
		{
			return false;
		}
	}

	function fieldType($offset, $query_id=0)
	{
		if(!$query_id)
		{
			$query_id = $this->query_result;
		}
		if($query_id)
		{
			$result = @mysql_field_type($query_id, $offset);
			return $result;
		}
		else
		{
			return false;
		}
	}

	function fetchField($field, $rownum=-1, $query_id=0)
	{
		if(!$query_id)
		{
			$query_id = $this->query_result;
		}
		if($query_id)
		{
			if($rownum > -1)
			{
				$result = @mysql_result($query_id, $rownum, $field);
			}
			else
			{
				if(empty($this->row[''.$query_id.'']) && empty($this->rowset[$query_id]))
				{
					if($this->sql_fetchrow())
					{
						$result = $this->row[''.$query_id.''][$field];
					}
				}
				else
				{
					if($this->rowset[''.$query_id.''])
					{
						$result = $this->rowset[''.$query_id.''][$field];
					}
					else if($this->row[''.$query_id.''])
					{
						$result = $this->row[''.$query_id.''][$field];
					}
				}
			}
			return $result;
		}
		else
		{
			return false;
		}
	}

	function rowSeek($rownum, $query_id=0)
    {
		if(!$query_id)
		{
			$query_id = $this->query_result;
		}
		if($query_id)
		{
			$result = @mysql_data_seek($query_id, $rownum);
			return $result;
		}
		else
		{
			return false;
		}
	}

	function freeResult($query_id=0)
    {
		if(!$query_id)
		{
			$query_id = $this->query_result;
		}

		if ( $query_id )
		{
			unset($this->row[''.$query_id.'']);
			unset($this->rowset[''.$query_id.'']);

			@mysql_free_result($query_id);

			return true;
		}
		else
		{
			return false;
		}
	}

	function insertID()
    {
		if($this->db_connect_id)
        {
			$result = @mysql_insert_id($this->db_connect_id);
			return $result;
		}
        else
        {
			return false;
		}
	}

	function optimize_table($table)
	{
		$this->query("OPTIMIZE TABLE {$this->prefix}{$table}");
	}

	function analyze_table($table)
	{
		$this->query("ANALYZE TABLE {$this->prefix}{$table}");
	}

	function index_exists($table, $index)
	{
		$index_exists = false;
		$query = $this->query("SHOW INDEX FROM {$this->prefix}{$table}");
		while($ukey = $this->fetchRow($query))
		{
			if($ukey['Key_name'] == $index)
			{
				$index_exists = true;
				break;
			}
		}

		if($index_exists)
		{
			return true;
		}

		return false;
	}

	function drop_column($table, $column)
	{
		return $this->query("ALTER TABLE {$this->prefix}{$table} DROP {$column}");
	}

	function add_column($table, $column, $definition)
	{
		return $this->query("ALTER TABLE {$this->prefix}{$table} ADD {$column} {$definition}");
	}

	function modify_column($table, $column, $new_definition)
	{
		return $this->query("ALTER TABLE {$this->prefix}{$table} MODIFY {$column} {$new_definition}");
	}

	function rename_column($table, $old_column, $new_column, $new_definition)
	{
		return $this->query("ALTER TABLE {$this->prefix}{$table} CHANGE {$old_column} {$new_column} {$new_definition}");
	}

	function fetch_size($table='')
	{
		if($table != '')
		{
			$query = $this->query("SHOW TABLE STATUS LIKE '".$this->prefix.$table."'");
		}
		else
		{
			$query = $this->query("SHOW TABLE STATUS");
		}
		$total = 0;
		while($table = $this->fetchRow($query))
		{
			$total += $table['Data_length']+$table['Index_length'];
		}
		return $total;
	}

	function show_create_table($table)
	{
		$query = $this->query("SHOW CREATE TABLE {$this->prefix}{$table}");
		$structure = $this->fetchRow($query);
		return $structure['Create Table'];
	}

	function drop_table($table, $hard=false, $table_prefix=true)
	{
		if($table_prefix == false)
		{
			$table_prefix = "";
		}
		else
		{
			$table_prefix = $this->prefix;
		}

		if($hard == false)
		{
			$this->query('DROP TABLE IF EXISTS '.$table_prefix.$table);
		}
		else
		{
			$this->query('DROP TABLE '.$table_prefix.$table);
		}
	}

	function list_tables($database, $prefix='')
	{
		if($prefix)
		{
			$query = $this->query("SHOW TABLES FROM `$database` LIKE '".$this->escapestring($prefix)."%'");
		}
		else
		{
			$query = $this->query("SHOW TABLES FROM `$database`");
		}

		while(list($table) = mysql_fetch_array($query))
		{
			$tables[] = $table;
		}

		return $tables;
	}

	function tableExists($table)
	{
		// Execute on master server to ensure if we've just created a table that we get the correct result
		$query = $this->query("
			SHOW TABLES
			LIKE '{$this->prefix}{$table}'
		");
		$exists = $this->numrows($query);
		if($exists > 0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	function fieldExists($field, $table)
	{
		$query = $this->query("
			SHOW COLUMNS
			FROM {$this->prefix}$table
			LIKE '$field'
		");
		$exists = $this->numrows($query);
		if($exists > 0)
		{
			return true;
		}
		else
		{
			return false;
		}
	}

	function escapeString($string)
    {
	    $string = str_replace(array("|nline|", "|rnline|", "\r\n", "\n"),array("", "", "|rnline|", "|nline|"), $string);
		if(get_magic_quotes_gpc())
		{
			$string = stripslashes($string);
		}
		//check if this function exists
		if(function_exists("mysql_real_escape_string") && $this->db_connect_id)
		{       
			$string = mysql_real_escape_string($string, $this->db_connect_id);
		}
		//for PHP version < 4.3.0 use addslashes
		else
		{
			$string = addslashes($string);
		}
	    $string = str_replace(array("|nline|", "|rnline|"),array("\n", "\r\n"), $string);
		return $string;
	}

	function error_number()
    {
		if($this->db_connect_id)
		{
			return @mysql_errno($this->db_connect_id);
		}
		else
		{
			return @mysql_errno();
		}
	}

	function error_string()
    {
		if($this->db_connect_id)
		{
			return @mysql_error($this->db_connect_id);
		}
		else
		{
			return @mysql_error();
		}
	}

	function error($string="")
	{
		if($this->error_reporting)
		{
				print("\n<!-- ERROR SQL! -->\n<div style='background:#FFCCCC;border:#FF6A6A 1px solid;padding:5px;margin:5px;direction:ltr;text-align:left'>\n<strong>[SQL] [".$this->error_number()."] ".$this->error_string()."</strong><br />\n<b>STRING:</b> {$string}\n</div>\n<!-- Pars Nuke CMS! -->\n\n");
		}
		else
		{
			    return false;
		}
	}

	function get_version()
	{
		if($this->version)
		{
			return $this->version;
		}
		$query = $this->query("SELECT VERSION() as version");
		$ver = $this->fetchRow($query);
		if($ver['version'])
		{
			$version = explode(".", $ver['version'], 3);
			$this->version = intval($version[0]).".".intval($version[1]).".".intval($version[2]);
		}
		return $this->version;
	}

	function get_execution_time()
    {
		static $time_start;
		$time = microtime(true);
		// Just starting timer, init and return
		if(!$time_start)
		{
			$time_start = $time;
			return;
		}
		// Timer has run, return execution time
		else
		{
			$total = $time-$time_start;
			$time_start = 0;
			if($total < 0) $total = 0;
			return $total;
		}
	}

	function close()
	{
		if($this->db_connect_id)
		{
			if($this->query_result)
			{
				@mysql_free_result($this->query_result);
			}
			$result = @mysql_close($this->db_connect_id);
			return $result;
		}
		else
		{
			return false;
		}
	}
}

?>