<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: copyright.php 2012-01-28 19:10:21 (Iman92)$
 */

if (stristr(htmlentities($_SERVER['PHP_SELF']), "includes/copyright.php")) {
    Header("Location: ../index.php");
    die();
}

if (!function_exists("escapeHexEntity")):
function escapeHexEntity($string) {
    $return = '';
    for ($x=0; $x < strlen($string); $x++) {
            $return .= '&#x' . bin2hex($string[$x]) . ';';
    }
    return $return;
}
endif;

function show_copyright() {
    global $module_name, $author_name, $author_user_email, $author_homepage, $license, $download_location, $module_version, $module_description;
    $module_name = str_replace("_", " ", $module_name);
    if ($author_name == "") { $author_name = "N/A"; }
    if ($author_user_email == "") { $author_user_email = "N/A"; }
    if ($author_homepage == "") { $author_homepage = "N/A"; }
    if ($license == "") { $license = "N/A"; }
    if ($download_location == "") { $download_location = "N/A"; }
    if ($module_version == "") { $module_version = "N/A"; }
    if ($module_description == "") { $module_description = "N/A"; }
    echo "<html>\n";
    echo "<head>\n";
    echo "<title>{$module_name}: Copyright Information</title>\n";
    echo "<meta http-equiv=\"Content-Language\" content=\"fa\" />\n";
    echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n";
    echo "<meta http-equiv=\"Designer\" content=\"Iman Moodi\" />\n";
    echo "<meta name=\"generator\" content=\"Pars Nuke Copyright (c) ".date("Y")." by Iman Moodi.\" />\n";
    echo "<meta name=\"description\" content=\"{$module_name}: Copyright Information\">\n";
    echo "<meta name=\"keywords\" content=\"$module_name, Nuke, PHP, Pars, ParsNuke, Free, Cms, Blog, Module, Weblog, Persian, Iran, Iranian, Farsi, Weblogs, Blogs\">\n";
    echo "<link rel=\"shortcut icon\" type=\"image/x-icon\" href=\"../../images/favicon.ico\">\n";
    echo "<style>\n";
    echo "body { background: White; font-family: Verdana, Helvetica; font-size: 9pt; color: Black; padding: 0px; margin: 0px; text-shadow: 1px 1px 0px White; cursor: default; }\n";
    echo "a { text-decoration: none; color: Black; -webkit-transition: all 0.3s ease-in; -moz-transition: all 0.3s ease-in; -o-transition: all 0.3s ease-in; transition: all 0.3s ease-in; }\n";
    echo "a:hover { color: Blue; }\n";
    echo "img { max-width: 99%; }\n";
    echo "table { width: 100%; font-size: 9pt; font-weight: bold; }\n";
    echo "th { background: #AAAAAA; color: White; text-shadow: 1px 1px 0px Black; }\n";
    echo "th a { color: White; text-shadow: 1px 1px 0px Black; }\n";
    echo "th a:hover { color: #CC0000; }\n";
    echo "</style>\n";
    echo "</head>\n";
    echo "<body>\n";
    echo "<div align=\"center\">\n";
    echo "<table cellpadding=\"10\" cellspacing=\"5\">\n";
    echo "<tr>\n";
    echo "     <th colspan=\"3\">Module Copyright &copy; Information</th>\n";
    echo "</tr>\n";
    echo "<tr>\n";
    echo "     <td style=\"width: 7px;background: #EEEEEE\"><img src=\"../../images/arrow.gif\" border=\"0\"></td>\n";
    echo "     <td style=\"width: 150px;background: #EEEEEE\">Module's Name:</td>\n";
    echo "     <td style=\"text-align: left;background: #F2FDFF\">{$module_name}</td>\n";
    echo "</tr>\n";
    echo "<tr>\n";
    echo "     <td style=\"background: #EEEEEE\"><img src=\"../../images/arrow.gif\" border=\"0\"></td>\n";
    echo "     <td style=\"background: #EEEEEE\">Module's Version:</td>\n";
    echo "     <td style=\"text-align: left;background: #F2FDFF\">{$module_version}</td>\n";
    echo "</tr>\n";
    echo "<tr>\n";
    echo "     <td style=\"background: #EEEEEE\"><img src=\"../../images/arrow.gif\" border=\"0\"></td>\n";
    echo "     <td style=\"background: #EEEEEE\">Module's Description:</td>\n";
    echo "     <td style=\"text-align: left;background: #F2FDFF\">{$module_description}</td>\n";
    echo "</tr>\n";
    echo "<tr>\n";
    echo "     <td style=\"background: #EEEEEE\"><img src=\"../../images/arrow.gif\" border=\"0\"></td>\n";
    echo "     <td style=\"background: #EEEEEE\">License:</td>\n";
    echo "     <td style=\"text-align: left;background: #F2FDFF\">{$license}</td>\n";
    echo "</tr>\n";
    echo "<tr>\n";
    echo "     <td style=\"background: #EEEEEE\"><img src=\"../../images/arrow.gif\" border=\"0\"></td>\n";
    echo "     <td style=\"background: #EEEEEE\">Author's Name:</td>\n";
    echo "     <td style=\"text-align: left;background: #F2FDFF\">{$author_name}</td>\n";
    echo "</tr>\n";
    echo "<tr>\n";
    echo "     <td style=\"background: #EEEEEE\"><img src=\"../../images/arrow.gif\" border=\"0\"></td>\n";
    echo "     <td style=\"background: #EEEEEE\">Author's Email:</td>\n";
    echo "     <td style=\"text-align: left;background: #F2FDFF\">".escapeHexEntity($author_user_email)."</td>\n";
    echo "</tr>\n";
    echo "<tr>\n";
    echo "     <th colspan=\"3\">[ <a href=\"{$author_homepage}\" target=\"_blank\">Author's HomePage</a> | <a href=\"{$download_location}\" target=\"_blank\">Module's Download</a> | <a href=\"http://ParsNuke.com/\" target=\"_blank\">ParsNuke</a> ]</th>\n";
    echo "</tr>\n";
    echo "</table>\n";
    echo "</div>\n";
    echo "</body>\n";
    echo "</html>";
}

?>