<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: functions_bbcode.php 2012-01-28 19:10:21 (Iman92)$
 */

if (stristr(htmlentities($_SERVER['PHP_SELF']), "functions_bbcode.php")) {
	Header("Location: ../index.php");
	die();
}

// Trim a line of text to a preferred length
function trimlink($text, $length) {
	$dec = array("&", "\"", "'", "\\", '\"', "\'", "<", ">");
	$enc = array("&amp;", "&quot;", "&#39;", "&#92;", "&quot;", "&#39;", "&lt;", "&gt;");
	$text = str_replace($enc, $dec, $text);
	if (strlen($text) > $length) $text = substr($text, 0, ($length-3))."...";
	$text = str_replace($dec, $enc, $text);
	return $text;
}

if (!function_exists("img_bbcode_callback")) {
	function img_bbcode_callback($matches) {
		if (substr($matches[3], -1, 1) != "/") {
			return "<span style='display: block; width: 300px; max-height: 300px; overflow: auto;' class='pars_forum-img-wrapper'><img src='".$matches[1].str_replace(array("?","&amp;","&","="), "", $matches[3]).$matches[4]."' alt='".$matches[3].$matches[4]."' style='border:0px' class='pars_forum-img' /></span>";
		} else {
			return $matches[0];
		}
	}
}

function pn_smileys_code($textarea, $form)
{
    global $db, $cache;
    if (!isset($cache->smileys) || !is_array($cache->smileys) || !count($cache->smileys)) {
        $cache->smileys = array();
        $result = $db->query("SELECT * FROM #__smileys order by smiley_id asc");
        while ($row = $db->fetchRow($result)) {
            $cache->smileys[ $row["smiley_id"] ] = $row;
        }
        $db->freeResult($result);
        unset($result, $row);
    }
	$bb  = "<input type='image' src='images/bbcodes/smiley.png' class='pn_bbcode' onclick=\"pn_overlay(this, 'pn_bbcode_smileys_list_{$textarea}', 'bottomright');return false;\"   title='شکلک ها' />\n";
	$bb .= "<div id='pn_bbcode_smileys_list_{$textarea}' class='pn_bbcode-popup' style='display:none;border:1px solid black;position:absolute;overflow:auto;width:300px;height:auto;' onclick=\"pn_overlayclose('pn_bbcode_smileys_list_{$textarea}');\">\n";
    foreach($cache->smileys as $smiley)
	$bb .= "<img src='images/smiley/{$smiley['smiley_image']}' alt='{$smiley['smiley_text']}' title='{$smiley['smiley_text']}' onclick=\"pn_insertText('{$textarea}', '{$smiley['smiley_code']}', '{$form}');\" />\n";
	$bb .= "</div>\n";
    unset($smiley);
    return $bb;
}

function pn_smileys($text)
{
    global $db, $cache;
    if (!isset($cache->smileys) || !is_array($cache->smileys) || !count($cache->smileys)) {
        $cache->smileys = array();
        $result = $db->query("SELECT * FROM #__smileys order by smiley_id asc");
        while ($row = $db->fetchRow($result)) {
            $cache->smileys[ $row["smiley_id"] ] = $row;
        }
        $db->freeResult($result);
        unset($result, $row);
    }
    foreach($cache->smileys as $smiley)
	$text = str_replace($smiley['smiley_code'], "<img src='images/smiley/{$smiley['smiley_image']}' alt='{$smiley['smiley_text']}' />", $text);
    unset($smiley);
    return $text;
}

function pn_bbcodes($textarea, $form, $bbcodes="smileys,b,i,u,url,mail,img,center,left,right,justify,big,small,code,quote,hide")
{
    set_head("<script type=\"text/javascript\" src=\"includes/pars_nuke/javascript/bbcode.js\"></script>");
    $bbcodes_lng = array();
    $bbcodes_lng['b'] = "متن را به صورت درشت نشان مي دهد";
    $bbcodes_lng['i'] = "متن را به صورت کج نشان مي دهد";
    $bbcodes_lng['u'] = "متن را به صورت زير خط دار نشان مي دهد";
    $bbcodes_lng['url'] = "يک آدرس قابل کليک کردن مي شود";
    $bbcodes_lng['mail'] = "يک آدرس ايميل را قابل کليک کردن مي کند";
    $bbcodes_lng['img'] = "تصوير را از آدرس داده شده نمايش مي دهد";
    $bbcodes_lng['center'] = "متن را وسط چين مي کند";
    $bbcodes_lng['left'] = "متن را چب چين مي کند";
    $bbcodes_lng['right'] = "متن را راست چين مي کند";
    $bbcodes_lng['justify'] = "متن را مرتب مي کند";
    $bbcodes_lng['big'] = "متن را بزرگ مي كند";
    $bbcodes_lng['small'] = "متن انتخابي شده را کوچک نمايش مي دهد";
    $bbcodes_lng['code'] = "متن را به عنوان کد نمايش مي دهد";
    $bbcodes_lng['quote'] = "متن را به عنوان نقل قول نمايش مي دهد";
    $bbcodes_lng['hide'] = "نمايش متن فقط براي كاربران";
    $bbcodes = explode(",", $bbcodes);
	$bb = "<div style='width:100%'>\n";
    foreach($bbcodes as $bbcode) {
         if (empty($bbcode)) continue;
         if ($bbcode == 'smileys') {
	          $bb .= pn_smileys_code($textarea, $form);
         } else {
	          $bb .= "<input type='image' src='images/bbcodes/{$bbcode}.png' class='pn_bbcode' onclick=\"pn_addText('{$textarea}','[{$bbcode}]','[/{$bbcode}]','{$form}');return false;\" title='".(isset($bbcodes_lng[$bbcode])? $bbcodes_lng[$bbcode] : "توضيحي وجود ندارد!")."' />\n";
         };
    }
	$bb .= "</div>";
    return $bb;
}

function pn_htmlcode($string)
{
    $string = pn_smileys($string);
    $string = preg_replace('#\[b\](.*?)\[/b\]#si', '<strong>\\1</strong>', $string);
    $string = preg_replace('#\[i\](.*?)\[/i\]#si', '<i>\\1</i>', $string);
    $string = preg_replace('#\[u\](.*?)\[/u\]#si', '<u>\\1</u>', $string);
    $string = preg_replace('#\[big\](.*?)\[/big\]#si', '<big style=\'font-size:16px\'>\1</big>', $string);

    $string = preg_replace('#\[url\]([\r\n]*)(http://|ftp://|https://|ftps://)([^\s\'\"]*?)([\r\n]*)\[/url\]#sie', "'<a href=\'\\2\\3\' target=\'_blank\' title=\'\\2\\3\' rel=\'nofollow\'>'.trimlink('\\2\\3', 20).(strlen('\\2\\3')>30?substr('\\2\\3', strlen('\\2\\3')-10, strlen('\\2\\3')):'').'</a>'", $string);
    $string = preg_replace('#\[url\]([\r\n]*)([^\s\'\"]*?)([\r\n]*)\[/url\]#sie', "'<a href=\'http://\\2\' target=\'_blank\' title=\'\\2\' rel=\'nofollow\'>'.trimlink('\\2', 20).(strlen('\\2')>30?substr('\\2', strlen('\\2')-10, strlen('\\2')):'').'</a>'", $string);
    $string = preg_replace('#\[url=([\r\n]*)(http://|ftp://|https://|ftps://)([^\s\'\"]*?)\](.*?)([\r\n]*)\[/url\]#si', '<a href=\'\2\3\' target=\'_blank\' title=\'\2\3\' rel=\'nofollow\'>\4</a>', $string);
    $string = preg_replace('#\[url=([\r\n]*)([^\s\'\"]*?)\](.*?)([\r\n]*)\[/url\]#si', '<a href=\'http://\2\' target=\'_blank\' title=\'\2\' rel=\'nofollow\'>\3</a>', $string);

    $string = preg_replace('#\[mail\]([\r\n]*)([^\s\'\";:\+]*?)([\r\n]*)\[/mail\]#sie', "hide_email('\\2').''", $string);
    $string = preg_replace('#\[mail=([\r\n]*)([^\s\'\";:\+]*?)\](.*?)([\r\n]*)\[/mail\]#sie', "hide_email('\\2').''", $string);

    $string = preg_replace_callback("#\[img\]((http|ftp|https|ftps)://)(.*?)(\.(jpg|jpeg|gif|png|JPG|JPEG|GIF|PNG))\[/img\]#si", "img_bbcode_callback", $string);

    $string = preg_replace('#\[center\](.*?)\[/center\]#si', '<div style=\'text-align:center\'>\1</div>', $string);
    $string = preg_replace('#\[left\](.*?)\[/left\]#si', '<div style=\'text-align:left\'>\1</div>', $string);
    $string = preg_replace('#\[right\](.*?)\[/right\]#si', '<div style=\'text-align:right\'>\1</div>', $string);
    $string = preg_replace('#\[justify\](.*?)\[/justify\]#si', '<div style=\'text-align:justify\'>\1</div>', $string);
    $string = preg_replace('#\[small\](.*?)\[/small\]#si', '<small class=\'pars_small\'>\1</small>', $string);

    $code_count = substr_count($string, "[code]");
    for ($i=0; $i < $code_count; $i++) {
    	$string = preg_replace("#\[code\](.*?)\[/code\]#sie", "'<div class=\'pars_code_bbcode\' style=\'width:99%;white-space:nowrap;overflow:auto\'><code>'.nl2br(pn_safe(stripslashes('\\1'), 'showhtml')).'</code></div>'", $string, 1);
    }

    $qcount = substr_count($string, "[quote]");
    for ($i=0;$i < $qcount;$i++)
    $string = preg_replace('#\[quote\](.*?)\[/quote\]#si', '<blockquote class=\'pars_quote\'>\1</blockquote>', $string);

    if (is_admin()) {
    	$string = preg_replace('#\[hide\](.*?)\[/hide\]#si', '<div class=\'pars_bbcode_hide_admin\'><strong>قسمت قرمز رنگ به صورت مخفي قرار داده شده است.</strong><br /><span style=\'color:red;font-weight:bold\'>\1</span></div>', $string);
    } elseif (is_member()) {
    	$string = preg_replace('#\[hide\](.*?)\[/hide\]#si', '\1', $string);
    } else {
    	$string = preg_replace('#\[hide\](.*?)\[/hide\]#si', '<div class=\'pars_bbcode_hide\'><span style=\'color:red;font-weight:bold\'>اين قسمت را فقط اعضاي سايت مي توانند مشاهده كنند!</span></div>', $string);
    }

    $count = preg_match_all("#\[olist=(1|a|A|i|I)\](.*?)\[/olist\]#si", $string, $match, PREG_PATTERN_ORDER);
    for ($i=0; $i<$count; $i++) {
    	$listitems = explode("\n", $match[2][$i]);
    	$listtext = "<ol type='".$match[1][$i]."'>";
    	foreach($listitems as $item) {
    		$item = trim($item);
    		if(!empty($item)) {
    			$listtext .= "<li>".$item."</li>";
    		}
    	}
    	$listtext .= "</ol>";
    	$string = str_replace($match[0][$i], $listtext, $string);
    }
    unset($listitems, $listtext, $match, $code_count);

    return $string;
}

?>