<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: css.php 2012-02-14 06:21:47 (Iman92)$
 */

function minify_css($str) {
	$res = '';
	$i=0;
	$inside_block = false;
	$current_char = '';
	while ($i+1<strlen($str)) {
		if ($str[$i]=='"' || $str[$i]=="'") {//quoted string detected
			$res .= $quote = $str[$i++];
			$url = '';
			while ($i<strlen($str) && $str[$i]!=$quote) {
				if ($str[$i] == '\\') {
					$url .= $str[$i++];
				}
				$url .= $str[$i++];
			}
			if (strtolower(substr($res, -5, 4))=='url(' || strtolower(substr($res, -9, 8)) == '@import ') {
				$url = convertUrl($url, substr_count($str, $url));
			}
			$res .= $url;
			$res .= $str[$i++];
			continue;
		} elseif (strtolower(substr($res, -4))=='url(') {//url detected
			$url = '';
			do {
				if ($str[$i] == '\\') {
					$url .= $str[$i++];
				}
				$url .= $str[$i++];
			} while ($i<strlen($str) && $str[$i]!=')');
			$url = convertUrl($url, substr_count($str, $url));
			$res .= $url;
			$res .= $str[$i++];
			continue;
		} elseif ($str[$i].$str[$i+1]=='/*') {//css comment detected
			$i+=3;
			while ($i<strlen($str) && $str[$i-1].$str[$i]!='*/') $i++;
			if ($current_char == "\n") $str[$i] = "\n";
			else $str[$i] = ' ';
		}
		
		if (strlen($str) <= $i+1) break;
		
		$current_char = $str[$i];
		
		if ($inside_block && $current_char == '}') {
			$inside_block = false;
		}
		
		if ($current_char == '{') {
			$inside_block = true;
		}
		
		if (preg_match('/[\n\r\t ]/', $current_char)) $current_char = " ";
		
		if ($current_char == " ") {
			$pattern = $inside_block?'/^[^{};,:\n\r\t ]{2}$/':'/^[^{};,>+\n\r\t ]{2}$/';
			if (strlen($res) &&	preg_match($pattern, $res[strlen($res)-1].$str[$i+1]))
				$res .= $current_char;
		} else $res .= $current_char;
		
		$i++;
	}
	if ($i<strlen($str) && preg_match('/[^\n\r\t ]/', $str[$i])) $res .= $str[$i];
	return $res;
}

?>