<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: mainfile.php 2012-01-28 19:10:21 (Iman92)$
 */

if (stristr(htmlentities($_SERVER['PHP_SELF']), "mainfile.php")) {
    Header("Location: index.php");
    exit();
}

ob_start();

if(function_exists('date_default_timezone_set'))
date_default_timezone_set('Asia/Tehran');

if(function_exists('mb_internal_encoding'))
{
    @mb_internal_encoding('UTF-8');
}

define('INCLUDE_PATH', dirname(__FILE__)."/");

if(@ini_get("safe_mode")==1)
define('PN_IS_SAFEMODE', 1);
else
define('PN_IS_SAFEMODE', 0);

// Get php version
$phpver = phpversion();

if (!isset($_REQUEST['no_gzip']) || $_REQUEST['no_gzip']=='yes'):
if ($phpver >= '4.0.4pl1' && isset($_SERVER['HTTP_USER_AGENT']) && strstr($_SERVER['HTTP_USER_AGENT'],'compatible')) {
	if (extension_loaded('zlib')) {
    	@ob_end_clean();
    	@ob_start('ob_gzhandler');
  	}
} elseif ($phpver > '4.0' && isset($_SERVER['HTTP_ACCEPT_ENCODING']) && !empty($_SERVER['HTTP_ACCEPT_ENCODING'])) {
  	if (strstr($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip')) {
    	if (extension_loaded('zlib')) {
      		$do_gzip_compress = true;
      		@ob_start(array('ob_gzhandler',5));
      		@ob_implicit_flush(0);
      		if (@ereg("MSIE", $_SERVER['HTTP_USER_AGENT'])) {
				Header('Content-Encoding: gzip');
      		}
    	}
  	}
}
endif;

if (!ini_get('register_globals')) {
	@import_request_variables("GPC", "");
}

if(!function_exists('stripos')) {
  function stripos_clone($haystack, $needle, $offset=0) {
    $return = strpos(strtoupper($haystack), strtoupper($needle), $offset);
  if ($return === false) {
    return false;
    } else {
    return true;
    }
  }
} else {
// But when this is PHP5, we use the original function
  function stripos_clone($haystack, $needle, $offset=0) {
    $return = stripos($haystack, $needle, $offset=0);
  if ($return === false) {
    return false;
    } else {
    return true;
    }
  }
}

if(isset($admin) && $admin == $_COOKIE['admin'])
{
	$admin = base64_decode($admin);
	$admin = addslashes($admin);
	$admin = base64_encode($admin);
}

if(isset($adminKey) && $adminKey == $_COOKIE['adminKey'])
{
	$adminKey = addslashes($adminKey);
}

if(isset($member) && $member == $_COOKIE['member'])
{
	$member = base64_decode($member);
	$member = addslashes($member);
	$member = base64_encode($member);
}

if(isset($loginKey) && $loginKey == $_COOKIE['loginKey'])
{
	$loginKey = addslashes($loginKey);
}

if (!defined('ADMIN_FILE')) {
     pn_post_check($_POST);
};

function pn_post_check($post) {
     // Die message for not allowed HTML tags
     $htmltags  = "<br><br><b><br><br><br><br>";
     $htmltags .= "<center><img src=\"images/logo.png\"><br><br><b>";
     $htmltags .= "The html tags you attempted to use are not allowed</b><br><br>";
     $htmltags .= "[ <a href=\"javascript:history.go(-1)\"><b>Go Back</b></a> ]</center>";
     foreach ($post as $key => $secvalue) {
        if(is_array($secvalue)) {
           pn_post_check($secvalue);
        } else{
           if ((@eregi("<[^>]*iframe*\"?[^>]*", $secvalue)) ||
              (@eregi("<[^>]*object*\"?[^>]*", $secvalue)) ||
              (@eregi("<[^>]*applet*\"?[^>]*", $secvalue)) ||
              (@eregi("<[^>]*meta*\"?[^>]*", $secvalue)) ||
              (@eregi("<[^>]*onmouseover*\"?[^>]*", $secvalue)) ||
              (@eregi("<[^>]script*\"?[^>]*", $secvalue)) ||
              (@eregi("<[^>]*body*\"?[^>]*", $secvalue)) ||
              (@eregi("<[^>]style*\"?[^>]*", $secvalue))) {
              die($htmltags);
           };
        }
     };
}

define('NUKE_FILE', true);

require_once(INCLUDE_PATH."includes/class_firewall.php");
$firewall = new firewall;

require_once(INCLUDE_PATH."includes/class_error.php");
$debug = new debug;

// Include the required files
@require_once(INCLUDE_PATH."configuration.php");

if(!$dbname) {
    die("<br><br><center><img src=images/logo.png><br><br><b>There seems that Pars Nuke isn't installed yet.<br>(The values in configuration.php file are the default ones)<br><br>You can proceed with the <a href='./setup/'>web installation</a> now.</center></b>");
}

require_once(INCLUDE_PATH."includes/class_mysql.php");
$db = new sql_db($dbhost, $dbuname, $dbpass, $dbname, $prefix, false);
if(!$db->db_connect_id) {
    die("<br><br><center><img src=images/logo.png><br><br><b>There seems to be a problem with the $dbtype server, sorry for the inconvenience.<br><br>We should be back shortly.</center></b>");
}

if(is_dir("setup")) {
    Header("Content-type: text/html; charset=utf-8");
    die("<br><br><center><img src=images/logo.png><br><br><b dir=rtl>پوشه <i>setup</i> يك ريسك امنيتي محصوب مي شود و تا زماني كه آن را حذف نكنيد سيستم به شما اجازه مشاهده سايت را نخواهد داد.</center></b>");
}

$firewall->escapeString_vars();
$pars = new stdClass;
$pars->input = array_merge($_GET, $_POST);

if($_SERVER['REQUEST_METHOD'] == "POST")
{
	  $pars->request_method = "post";
}
else if($_SERVER['REQUEST_METHOD'] == "GET")
{
	  $pars->request_method = "get";
}

require_once(INCLUDE_PATH."includes/class_html.php");
require_once(INCLUDE_PATH."includes/functions_jalaliDate.php");
require_once(INCLUDE_PATH."includes/ipban.php");
if (file_exists(INCLUDE_PATH."includes/custom_files/custom_mainfile.php")) {
	include_once(INCLUDE_PATH."includes/custom_files/custom_mainfile.php");
}

$pars->settings = array();
$pars->urls = array();
$pars->theme = array();
$pars->images = array();
$pars->urls = array();
$pars->hooks = array();
$pars->current_hook = null;
$cache = new stdClass;
$start_time = microtime(true);

get_settings("");
$firewall->check();

$language = $pars->settings['language'] = pn_safe($pars->settings['language'], "en-num");
$pars->theme['page_title'] = $pars->settings['sitename'];
$pars->theme['page_meta'] = array("description" => $pars->settings['slogan'], "keywords" => $pars->settings['keywords']);
$pars->theme['head_tags'] = '';
$pars->theme['footer_tags'] = '';
$op = $pars->input['op'] = pn_getParam('op', $pars->input);

// Error reporting, to be set in configuration.php
error_reporting(E_ALL^E_NOTICE);
if ($pars->settings['display_errors'] == 1) {
	 @ini_set('display_errors', 1);
} else {
	 @ini_set('display_errors', 0);
};

if (isset($newlang) AND !empty($newlang)) {
	 $newlang = pn_safe($newlang, "en-num");
	 if (file_exists(INCLUDE_PATH."language/lang-".$newlang.".php")) {
			pn_setcookie("lang",$newlang,time()+31536000);
			include_once(INCLUDE_PATH."language/lang-".$newlang.".php");
			$currentlang = $newlang;
	 } else {
			pn_setcookie("lang",$language,time()+31536000);
			include_once(INCLUDE_PATH."language/lang-".$language.".php");
			$currentlang = $language;
	 }
} elseif (isset($lang) AND !empty($lang)) {
	 $lang = pn_safe($lang, "en-num");
	 if (!file_exists(INCLUDE_PATH."language/lang-".$lang.".php"))
	 $lang = $language;
	 include_once(INCLUDE_PATH."language/lang-".$lang.".php");
	 $currentlang = $lang;
} else {
	 pn_setcookie("lang",$language,time()+31536000);
	 include_once(INCLUDE_PATH."language/lang-".$language.".php");
	 $currentlang = $language;
}

function get_lang($module, $type="site") {
   global $currentlang, $language;
   if ($type == "admin") {
      if (file_exists(INCLUDE_PATH."modules/$module/admin/language/lang-".$currentlang.".php")) {
         include_once(INCLUDE_PATH."modules/$module/admin/language/lang-".$currentlang.".php");
      } elseif (file_exists(INCLUDE_PATH."modules/$module/admin/language/lang-".$language.".php")) {
         include_once(INCLUDE_PATH."modules/$module/admin/language/lang-".$language.".php");
      }
   } else {
      if (file_exists(INCLUDE_PATH."modules/$module/language/lang-".$currentlang.".php")) {
         include_once(INCLUDE_PATH."modules/$module/language/lang-".$currentlang.".php");
      } elseif (file_exists(INCLUDE_PATH."modules/$module/language/lang-".$language.".php")) {
         include_once(INCLUDE_PATH."modules/$module/language/lang-".$language.".php");
      }
   }
}

/**
 * Add a hook onto which a plugin can be attached.
 *
 * @param string The hook name.
 * @param string The function of this hook.
 * @param int The priority this hook has.
 * @param string The optional file belonging to this hook.
 * @return boolean Always true.
 */
 function add_hook($hook, $function, $priority=10, $file="") {
		global $pars;
		// Check to see if we already have this hook running at this priority
		if(!empty($pars->hooks[$hook][$priority][$function]) && is_array($pars->hooks[$hook][$priority][$function]))
		{
			return true;
		}

		// Add the hook
		$pars->hooks[$hook][$priority][$function] = array(
			"function" => $function,
			"file" => $file
		);
		return true;
 }

 /**
  * Run the hooks that have modules.
  *
  * @param string The name of the hook that is run.
  * @param string The argument for the hook that is run. The passed value MUST be a variable
  * @return string The arguments for the hook.
  */
function run_hooks($hook, $arguments="") {
		global $pars;
		if(!isset($pars->hooks[$hook]) || !is_array($pars->hooks[$hook]))
		{
			return $arguments;
		}
		$pars->current_hook = $hook;
		ksort($pars->hooks[$hook]);
		foreach($pars->hooks[$hook] as $priority => $hooks)
		{
			if(is_array($hooks))
			{
				foreach($hooks as $hook)
				{
					if($hook['file'])
					{
						require_once $hook['file'];
					}

					$func = $hook['function'];
					$returnargs = $func($arguments);


					if($returnargs)
					{
						$arguments = $returnargs;
					}
				}
			}
		}
		$pars->current_hook = '';
		return $arguments;
}

/**
 * Remove a specific hook.
 *
 * @param string The name of the hook.
 * @param string The function of the hook.
 * @param string The filename of the plugin.
 * @param int The priority of the hook.
 */
function remove_hook($hook, $function, $file="", $priority=10) {
		global $pars;
		// Check to see if we don't already have this hook running at this priority
		if(!isset($pars->hooks[$hook][$priority][$function]))
		{
			return true;
		}
		unset($pars->hooks[$hook][$priority][$function]);
}

get_modules();

foreach ($cache->modules as $PN_module => $val) {
    if ($val['active']==0) continue;
	if(file_exists(INCLUDE_PATH."modules/{$PN_module}/{$PN_module}.config.php")){
		require_once(INCLUDE_PATH."modules/{$PN_module}/{$PN_module}.config.php");
	}
}
unset($PN_module, $val);

run_hooks("mainfile.start");

function get_settings($module) {
    global $db,$pars;
    static $saveSettings;
    $module = pn_safe($module, "en-num");
    if (isset($saveSettings[$module])) return false;

    $q = $db->query("SELECT * FROM `#__settings` WHERE `setting_module`='{$module}' ORDER BY `setting_name` ASC");
    while($row = $db->fetchRow($q)) {
         $pars->settings[ $row['setting_name'] ] = $row['setting_value'];
    }
    $db->freeResult($q);

    if (!isset($saveSettings)) $saveSettings = array();
    $saveSettings[$module] = $module;
}

function get_modules($new=false) {
    global $db,$pars, $cache;
    if ( ((!isset($cache->modules) || !is_array($cache->modules) || !count($cache->modules))) || $new) {
        $cache->modules = array();
        $result = $db->query("SELECT * FROM #__modules ORDER BY title ASC");
        while ($row = $db->fetchRow($result)) {
            $cache->modules[ $row["title"] ] = $row;
        }
        $db->freeResult($result);
    }
    unset($result, $row);
}

function odd_even($even='pars_even', $odd='pars_odd') {
     static $save;
     $save = (!$save || $save==$odd? $even : $odd);
     return $save;
}

function parsNuke_page($total, $limit=10, $pageNum=1, $url='?', $getName='pageNum') {
	$pageNum = $pageNum<=0? 1 : intval($pageNum);
	$limit = intval($limit)<=0? 1 : intval($limit);
	if($total=='SQL') {
		return ($pageNum-1) * $limit;
	}

	if($total <= $limit)
	return null;

	$max = ceil(intval($total)/$limit); // Number of pages
 	$html = '<div class="pars_pagination"><span>';

	if($pageNum-1 >= 1)
	$html .= '<a href="'.$url.$getName.'='.($pageNum-1).'" class="page_previous">&nbsp;&lt;&nbsp;</a>'."\n";

	for($i=1;$i<=$max;$i++) {
		$html .= '<a href="'.$url.$getName.'='.$i.'"'.($i==$pageNum? ' class="page_active"' : '').'>&nbsp;'.$i.'&nbsp;</a>'."\n";
	}

	if($pageNum+1 <= $max)
	$html .= '<a href="'.$url.$getName.'='.($pageNum+1).'" class="page_next">&nbsp;&gt;&nbsp;</a>'."\n";

	$html .= '</span></div><div class="clear"></div>';
	echo $html;
};

function parsNuke_check_xss() {
	$url = html_entity_decode( urldecode( $_SERVER['QUERY_STRING'] ) );
	$url = str_replace( "\\", "/", $url );

	if( $url ) {
		if( (strpos( $url, '<' ) !== false) || (strpos( $url, '>' ) !== false) || (strpos( $url, '"' ) !== false) || (strpos( $url, './' ) !== false) || (strpos( $url, '../' ) !== false) || (strpos( $url, '\'' ) !== false) || (strpos( $url, '.php' ) !== false) ) {
			die("Hacking attempt!");
		}
	}
	$url = html_entity_decode( urldecode( $_SERVER['REQUEST_URI'] ) );
	$url = str_replace( "\\", "/", $url );

	if( $url ) {
		if( (strpos( $url, '<' ) !== false) || (strpos( $url, '>' ) !== false) || (strpos( $url, '"' ) !== false) || (strpos( $url, '\'' ) !== false) ) {
			die("Hacking attempt!");
		}
	}
}

function pn_link($link, $type=1) {
     switch($type) {
          case '1':
          $link = 'modules.php?'.$link;
          break;

          case '2':
          $link = 'index.php?'.$link;
          break;
     }
     $link = str_replace('&', '&amp;', $link);
     return trim($link);
}

function get_ip() {
	if (!empty($_SERVER['HTTP_CLIENT_IP']))   //check ip from share internet
	{
		$ip=$_SERVER['HTTP_CLIENT_IP'];
	}
	elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))   //to check ip is pass from proxy
	{
		$ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
	}
	else
	{
		$ip=$_SERVER['REMOTE_ADDR'];
	}
	$ip = pn_safe($ip, "_nohtml");
	return $ip;
}

function pn_urlencode($text, $urlencode=false) {
	$text = trim(pn_safe($text, '_nohtml'));
	$text = str_replace(array('!','@','#','$','%','^','*','(',')','_','=','+','|','/','\\','~','`','\'','"','&','?','؟','>','<','.','…','‌',' '),'-',$text);
	$text = trim($text, '-');
	if($urlencode)
	$text = urlencode($text);
	return $text;
}

function pn_safe($text, $type='showhtml', $space=false) {
       $text = trim($text);
       switch($type) {
       case'en':
       $pattern = "A-Za-z-_";
       break;

       case'fa':
       $pattern = "-اآبپتثجچحخدذرزژسشصضطظعغفقكکگلمنوهیي_";
       break;

       case'fa-num':
       $pattern = "0-9-اآبپتثجچحخدذرزژسشصضطظعغفقكکگلمنوهیي_";
       break;

       case'en-fa-num':
       $pattern = "A-Za-z-0-9-اآبپتثجچحخدذرزژسشصضطظعغفقكکگلمنوهیي_";
       break;

       case'en-num':
       $pattern = "A-Za-z-0-9-_";
       break;

       case'nohtml':
       case'_nohtml':
       if($type=='_nohtml')
  	   $text = html_entity_decode($text, ENT_QUOTES, 'UTF-8');
  	   $text = strip_tags($text);
       return $text;
       break;

       case'htmldecode':
  	   $text = html_entity_decode($text, ENT_QUOTES, 'UTF-8');
       return $text;
       break;

       default:
       case'showhtml':
   	   $text = htmlentities($text, ENT_QUOTES, 'UTF-8');
	   $text = str_replace(array("<",">","'","\"","&amp;"),array("&lt;","&gt;","&#39;","&quot;","&"),$text);
       return $text;
       break;
       }
       if($space) $pattern = $pattern.' ';
       $text = preg_replace("([^$pattern]*)",'',$text);
       return $text;
}

function parsNuke_imports_filter($array) {
    global $db;
    if(is_array($array) && Count($array))
    {
         foreach($array as $key => $val)
         {
                if(is_array($val) && count($val))
                {
                       $array[$key] = parsNuke_imports_filter($val);
                }
                else
                {
                       $array[$key] = $db->escapeString($val);
                }
         }
    }
    return $array;
}

function parsNuke_ob_end_flush($_debug=true) {
    if ($_debug && isset($debug) && is_object($debug)) {
         if (is_admin()) {
           	    global $debug;
                echo $debug->Output();
         }
    }
    if (ob_get_length() !== FALSE) {
         ob_end_flush();
         parsNuke_ob_end_flush(false);
    }
    die;
}

function pn_redirect($url, $siteurl=true) {
    if ($siteurl) {
         global $pars;
         if (isset($pars->settings['siteurl']))
         $url = $pars->settings['siteurl'].'/'.$url;
    }
	$url = str_replace('&amp;', '&', $url);
	// First check if the current HTTP-Request is an Ajax-Request
	if (is_ajax()) {
	   	die('<script type="text/javascript">document.location.href="'.$url.'";</script>');
	}
	Header("Location: ".$url."");
    die("Link Redirect:<br /><br />Please click <a href=\"{$url}\">here.</a>");
}

function pn_refresh($url, $time=3, $siteurl=true) {
    if ($siteurl) {
         global $pars;
         if (isset($pars->settings['siteurl']))
         $url = $pars->settings['siteurl'].'/'.$url;
    }
	$url = str_replace('&amp;', '&', $url);
	// First check if the current HTTP-Request is an Ajax-Request
	if (is_ajax()) {
	   	die('<script type="text/javascript">document.location.href="'.$url.'";</script>');
	}
	Header("Refresh: ".intval($time)."; url=".$url."");
}

// Checks if the current HTTP-Request is an Ajax-Request
function is_ajax() {
	return (isset($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest');
}

/**
 * Unserialize value only if it was serialized.
 *
 * @since 1.0
 *
 * @param string $original Maybe unserialized original, if is needed.
 * @return mixed Unserialized data can be any type.
 * @copyright WordPress
 */
function pn_maybe_unserialize( $original ) {
	if ( pn_is_serialized( $original ) ) // don't attempt to unserialize data that wasn't serialized going in
		return @unserialize( $original );
	return $original;
}

/**
 * Check value to find if it was serialized.
 *
 * If $data is not an string, then returned value will always be false.
 * Serialized data is always a string.
 *
 * @since 1.0
 *
 * @param mixed $data Value to check to see if was serialized.
 * @return bool False if not serialized and true if it was.
 * @copyright WordPress
 */
function pn_is_serialized( $data ) {
	// if it isn't a string, it isn't serialized
	if ( !is_string( $data ) )
		return false;
	$data = trim( $data );
	if ( 'N;' == $data )
		return true;
	if ( !preg_match( '/^([adObis]):/', $data, $badions ) )
		return false;
	switch ( $badions[1] ) {
		case 'a' :
		case 'O' :
		case 's' :
			if ( preg_match( "/^{$badions[1]}:[0-9]+:.*[;}]\$/s", $data ) )
				return true;
			break;
		case 'b' :
		case 'i' :
		case 'd' :
			if ( preg_match( "/^{$badions[1]}:[0-9.E-]+;\$/", $data ) )
				return true;
			break;
	}
	return false;
}

/**
 * Check whether serialized data is of string type.
 *
 * @since 1.0
 *
 * @param mixed $data Serialized data
 * @return bool False if not a serialized string, true if it is.
 * @copyright WordPress
 */
function pn_is_serialized_string( $data ) {
	// if it isn't a string, it isn't a serialized string
	if ( !is_string( $data ) )
		return false;
	$data = trim( $data );
	if ( preg_match( '/^s:[0-9]+:.*;$/s', $data ) ) // this should fetch all serialized strings
		return true;
	return false;
}

// Javascript email encoder by Tyler Akins
// http://rumkin.com/tools/mailto_encoder/
function hide_email($email, $title = "", $subject = "") {
	if (strpos($email, "@")) {
		$parts = explode("@", $email);
		$MailLink = "<a href='mailto:".$parts[0]."@".$parts[1];
		if ($subject != "") { $MailLink .= "?subject=".urlencode($subject); }
		$MailLink .= "'>".($title?$title:$parts[0]."@".$parts[1])."</a>";
		$MailLetters = "";
		for ($i = 0; $i < strlen($MailLink); $i++) {
			$l = substr($MailLink, $i, 1);
			if (strpos($MailLetters, $l) === false) {
				$p = rand(0, strlen($MailLetters));
				$MailLetters = substr($MailLetters, 0, $p).$l.substr($MailLetters, $p, strlen($MailLetters));
			}
		}
		$MailLettersEnc = str_replace("\\", "\\\\", $MailLetters);
		$MailLettersEnc = str_replace("\"", "\\\"", $MailLettersEnc);
		$MailIndexes = "";
		for ($i = 0; $i < strlen($MailLink); $i ++) {
			$index = strpos($MailLetters, substr($MailLink, $i, 1));
			$index += 48;
			$MailIndexes .= chr($index);
		}
		$MailIndexes = str_replace("\\", "\\\\", $MailIndexes);
		$MailIndexes = str_replace("\"", "\\\"", $MailIndexes);

		$res = "<script type='text/javascript'>";
		$res .= "/*<![CDATA[*/";
		$res .= "ML=\"".str_replace("<", "xxxx", $MailLettersEnc)."\";";
		$res .= "MI=\"".str_replace("<", "xxxx", $MailIndexes)."\";";
		$res .= "ML=ML.replace(/xxxx/g, '<');";
		$res .= "MI=MI.replace(/xxxx/g, '<');";	$res .= "OT=\"\";";
		$res .= "for(j=0;j < MI.length;j++){";
		$res .= "OT+=ML.charAt(MI.charCodeAt(j)-48);";
		$res .= "}document.write(OT);";
		$res .= "/*]]>*/";
		$res .= "</script>";

		return $res;
	} else {
		return $email;
	}
}

/**
 * Summarize text
 * Author AHHP ~ Boplo.ir
 *
 * @param string $str Text to summarize.
 * @param integer $limit Number of characters to trim.
 * @param integer $offset Number of characters to
 *  move backward and/then forward of $limit
 *  for finding line/sentence/word ending.
 * @param array $endlineChars Known characters as
 *  line/sentence/word ending characters.
 * @return string Summarized string.
 *
 * Please note that
 *  Length of a latin text is NOT equal to a
 *  Unicode text in PHP (Farsi is Unicode).
 *  It means PHP counts e.g. 100 Farsi characters
 *  as 200 characters. So you should use bigger
 *  numbers as $limit and $offset parameters
 *  while using this function for Farsi texts.
 */
function summarize($str, $limit=600, $offset=100, $endlineChars=array('.','!','?',"\n",')',';',',','؟','،')) {
    if(strlen($str)<=$limit)
        return $str;

    for($i=$limit; $i>$limit-$offset; $i--) {
        if(in_array($str{$i}, $endlineChars)) {
            $length = $i;
            break;
        }
        if(!isset($spaceLength) && $str{$i}==' ')
            $spaceLength = $i;
    }
    if(isset($length))
        return substr($str, 0, $length+1);

    for($i=$limit; $i<$limit+$offset; $i++) {
        if(in_array($str{$i}, $endlineChars)) {
            $length = $i;
            break;
        }
        if(!isset($spaceLength) && $str{$i}==' ')
            $spaceLength = $i;
    }
    if(isset($length))
        return substr($str, 0, $length+1);

    if(isset($spaceLength))
        return substr($str, 0, $spaceLength);

    return substr($str, 0, $limit+1);
}

/**
 * Returns MIME Content-Type By filename
 *
 * @param string $filename File name or path
 * @return string New MIME-Type
*/
function get_mime($filename) {
    if(function_exists('finfo_file')) {
        $finfo = finfo_open(FILEINFO_MIME_TYPE);
        $mime = finfo_file($finfo, $filename);
        finfo_close($finfo);
        return $mime;
    }
    if(function_exists('mime_content_type')) {
        return mime_content_type($filename);
    }
    $map = array(
        'txt'=>'text/plain','htm'=>'text/html',
        'html'=>'text/html','php'=>'text/html',
        'css'=>'text/css','js'=>'application/javascript',
        'json'=>'application/json','xml'=>'application/xml',
        'swf'=>'application/x-shockwave-flash',
        'flv'=>'video/x-flv','png'=>'image/png',
        'jpe'=>'image/jpeg','jpeg'=>'image/jpeg',
        'jpg'=>'image/jpeg','gif'=>'image/gif',
        'bmp'=>'image/bmp','tiff'=>'image/tiff',
        'ico'=>'image/vnd.microsoft.icon',
        'tif'=>'image/tiff','svg'=>'image/svg+xml',
        'svgz'=>'image/svg+xml','zip'=>'application/zip',
        'rar'=>'application/x-rar-compressed',
        'exe'=>'application/x-msdownload',
        'msi'=>'application/x-msdownload',
        'cab'=>'application/vnd.ms-cab-compressed',
        'mp3'=>'audio/mpeg','qt'=>'video/quicktime',
        'mov'=>'video/quicktime','pdf'=>'application/pdf',
        'psd'=>'image/vnd.adobe.photoshop',
        'ai'=>'application/postscript',
        'eps'=>'application/postscript',
        'ps'=>'application/postscript',
        'doc'=>'application/msword','rtf'=>'application/rtf',
        'xls'=>'application/vnd.ms-excel',
        'ppt'=>'application/vnd.ms-powerpoint',
        'odt'=>'application/vnd.oasis.opendocument.text',
        'ods'=>'application/vnd.oasis.opendocument.spreadsheet'
    );
    $ext = end( explode('.',strtolower($filename)) );
    return (array_key_exists($ext, $map) ?
        $map[$ext] : 'application/octet-stream');
}

function pn_setcookie($cookieName, $cookieContent, $cookieExpiration='', $cookiePath='', $cookieDomain='', $secure=false, $httpOnly=false) {
    global $pars;
    if (empty($cookiePath))
	$cookiePath = $pars->settings['site_path'];
    if (empty($cookieDomain))
	$cookieDomain = $pars->settings['site_host'];
	$cookieDomain = $cookieDomain=='localhost'? false : $cookieDomain;
	if (version_compare(PHP_VERSION, '5.2.0', '>=')) {
			setcookie($cookieName, $cookieContent, $cookieExpiration, $cookiePath, $cookieDomain, $secure, $httpOnly);
	} else {
			setcookie($cookieName, $cookieContent, $cookieExpiration, $cookiePath, $cookieDomain, $secure);
	}
}

function pn_unsetcookie($cookieName) {
    pn_setcookie($cookieName, null, -3600);
}

/**
 * Returns the extension of a file.
 *
 * @param string The filename.
 * @return string The extension of the file.
 */
function get_extension($file) {
	return pn_strtolower(pn_substr(strrchr($file, "."), 1));
}

/**
 * Validates the format of an email address.
 *
 * @param string The string to check.
 * @return boolean True when valid, false when invalid.
 */
function validate_email_format($email)
{
    if (phpversion() >= '5.2.0') {
        return filter_var($email, FILTER_VALIDATE_EMAIL);
    } else {
		if(strpos($email, ' ') !== false)
		{
			return false;
		}
		// Valid local characters for email addresses: http://www.remote.org/jochen/mail/info/chars.html
		return preg_match("/^[a-zA-Z0-9&*+\-_.{}~^\?=\/]+@[a-zA-Z0-9-]+\.([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]{2,}$/si", $email);
    }
}

function ValidateUrl($url){
    if (phpversion() >= '5.2.0') {
        return filter_var($url, FILTER_VALIDATE_URL);
    } else {
        return preg_match('/^(http(s?)://|ftp://{1})((w+.){1,})w{2,}$/i', $url);
    }
}

function pn_go_back() {
	return ' <a href="javascript:history.go(-1);" target="_self" title="Go Back!">بازگشت به صفحه قبل</a> ';
}

function pn_menuMake($data ,$type=1) {
      $type = $type==2? 2 : '';
      $html = "<!-- PARSNUKE_MENU -->\n";
      $html .= "<div class=\"PARSNUKE_MENU\">\n";
      foreach($data["MENU"] as $_data) {
          $html .= "<a id=\"MENU-{$_data['id']}\" href=\"javascript:pn_Toggle('MENU-{$_data['id']}'".($type==2? ', 2': '').");\"><img src=\"images/menu/rtl/".(isset($_data['close'])? 'closed': 'open')."{$type}.gif\" border=\"0\"><b>{$_data['title']}</b></a>\n";
          $html .= "<div id=\"Parent-MENU-{$_data['id']}\"".(isset($_data['close'])? ' style="display: none"': '').">\n";
          if(isset($data["PARENT"][$_data['id']]) && is_array($data["PARENT"][$_data['id']]) && count($data["PARENT"][$_data['id']]))
          foreach($data["PARENT"][$_data['id']] as $__data) {
              $html .= "<a href=\"{$__data['url']}\"><img src=\"images/menu/rtl/arrow{$type}.gif\" border=\"0\">{$__data['title']}</a>\n";
          }
          $html .= "</div>\n";
      }
      $html .= "</div>\n";
      $html .= "<!-- /PARSNUKE_MENU -->\n";
      return $html;
}

function pn_message($message, $type='info', $close=true, $go_back=false) {
    switch($type) {
         case'0':
         case'error':
         $class = 'error';
         break;

         case'1':
         case'success':
         $class = 'success';
         break;

         case'2':
         case'info':
         default:
         $class = 'info';
         break;
    }
    $html  = "<div class=\"pars_message-{$class}\"";
    if ($close)
    $html .= " id=\"close-message\"";
    $html .= "><b>";
    $html .= $message;
    if($go_back)
    $html .= ' - <a href="javascript:history.go(-1);" target="_self" title="Go Back!" class="pars_goBack">بازگشت به صفحه قبل</a> ';
    $html .= "</b></div>";
    return $html;
}

function pn_error($message, $title="خطا در سيستم", $go_back=true) {
	set_title($title);
	openTable($title);
	echo pn_message($message, "error", false, false);
	if ($go_back && !is_ajax())
	echo '<div style="text-align: center">[ <a href="javascript:history.go(-1);" target="_self" title="Go Back!" class="pars_goBack">بازگشت به صفحه قبل</a> ]</div>';
	closeTable();
	get_footer();
	die();
}

function pn_str_replace($pattern, $val, $string) {
	 if(function_exists("str_ireplace"))
	 return str_ireplace($pattern, $val, $string);
	 else
	 return str_replace($pattern, $val, $string);
}

function pn_file_get_contents($file) {
	 if(file_exists($file))
	 return file_get_contents($file);
	 else
	 return "";
}

function pn_unlink($file) {
	 if(file_exists($file))
	 return unlink($file);
	 else
	 return false;
}

function pn_getParam($name, &$array, $default=false, $type='en-num', $space=false) {
	 if (!isset($array[$name]) || empty($array[$name]))
			return $default;

	 if ($type)
			return pn_safe($array[$name], $type, $space); // Sanatize for security, remove anything but 0-9,a-z,-_

	 return $array[$name];
}

function set_image($key, $image, $naw=false) {
    global $pars;
    if(!isset($pars->images[$key]) || $naw)
    $pars->images[$key] = $image;
}

function get_image($key) {
    global $pars;
    if(isset($pars->images[$key]))
    return $pars->images[$key];
    else
    return false;
}

function is_image($key) {
    global $pars;
    if(isset($pars->images[$key]))
    return true;
    else
    return false;
}

function makePass($add='!@#%^&*()_+=-:;?~', $length="8") {
	$cons = "QWERTYUIOPASDFGHJKLZXCVBNMbcdfghjklmnpqrstvwxyz1234567890".$add;
	$vocs = "aeiou";
	for ($x=0; $x < $length; $x++) {
		mt_srand ((double) microtime() * 1000000);
		$con[$x] = substr($cons, mt_rand(0, strlen($cons)-1), 1);
		$voc[$x] = substr($vocs, mt_rand(0, strlen($vocs)-1), 1);
	}
	mt_srand((double)microtime()*1000000);
	$num1 = mt_rand(0, 9);
	$num2 = mt_rand(0, 9);
	$makepass = $con[0] . $voc[0] .$con[2] . $num1 . $num2 . $con[3] . $voc[3] . $con[4];
	return($makepass);
}

function is_admin($type='') {
    if(!isset($_COOKIE['admin']) || !isset($_COOKIE['adminKey']) || empty($_COOKIE['admin']) || empty($_COOKIE['adminKey'])) return 0;
    static $adminSave, $saveDate;
    if(isset($adminSave) AND isset($saveDate) AND is_array($saveDate) AND count($saveDate) AND $type=='data') return $saveDate;
    elseif(isset($adminSave)) return $adminSave;
    global $prefix, $db, $sitekey;

    $admin = base64_decode($_COOKIE['admin']);
    $admin = $db->escapeString($admin);
    $admin = explode(':', $admin);

    $aid = pn_safe($admin[0], "en-num");
    $pwd = pn_safe($admin[1], "_nohtml");;
    $aid = substr($aid, 0, 25);

    $loginKey = $db->escapeString($_COOKIE['adminKey']);
	$PN_SERVER_NAME = str_replace('www.', '', $_SERVER['SERVER_NAME']);
    $key = sha1(md5($_SERVER['HTTP_USER_AGENT'].$sitekey.$PN_SERVER_NAME));

    if (!empty($aid) && !empty($pwd)) {
        $sql = "SELECT * FROM #__authors WHERE aid='$aid' LIMIT 1";
        $result = $db->query($sql);
        $row = $db->fetchRow($result);
        $db->freeResult($result);
    	if (md5($row['pwd']) == $pwd && !empty($row['pwd']) && $loginKey==sha1($row['key']) && $key==$loginKey) {
			 $row['aid'] = pn_safe($row['aid'], "en-num");
			 $row['aid'] = substr($aid, 0, 25);
			 $row['pwd'] = pn_safe(substr($row['pwd'], 0, 40), "_nohtml");
			 $row['radminsuper'] = intval($row['radminsuper']);
    		 $saveDate = $row;
    		 $adminSave = 1;
    		 if($type=='data')
    		 return $saveDate;
    		 else
    		 return $adminSave;
        }
    }
    return $adminSave = 0;
}

function is_superAdmin($type='') {
    if (!is_admin()) return false;
    global $adminData;
    $adminData = is_admin("data");
    if ($type=="data" && $adminData['radminsuper']==1)
    return $adminData;
    elseif ($adminData['radminsuper']==1)
    return true;
    return false;
}

function is_group($name) {
     global $prefix, $db;
     if (is_member()) {
          $memberData = is_member('data');
          $points = intval($memberData['member_points']);
          $result2 = $db->query("SELECT mod_group FROM ".$prefix."_modules WHERE title='$name'");
          $row2 = $db->fetchRow($result2);
          $mod_group = intval($row2['mod_group']);
          $db->freeResult($result2);
          $result3 = $db->query("SELECT points FROM ".$prefix."_groups WHERE id='$mod_group'");
          $row3 = $db->fetchRow($result3);
          $grp = intval($row3['points']);
          $db->freeResult($result3);
          if ($points >= $grp OR $mod_group == 0) {
        	  return 1;
          }
     }
     return 0;
}

function update_points($name) {
  global $prefix, $db, $memberData;
  if (is_member()) {
      $memberData = is_member('data');
      $username = pn_safe($memberData['member_name'], "en-num");
      $name = pn_safe($name, "en-num");
      if ($db->numRows($db->query("SELECT * FROM #__groups")) > 0) {
          $result = $db->query("SELECT points FROM #__groups_points WHERE name='$name'");
          list($points) = $db->fetchArray($result);
          $db->freeResult($result);
          $rpoints = intval($points);
          $db->query("UPDATE `#__members` SET `member_points`=member_points+".$rpoints." WHERE `member_name`='$username' limit 1");
      }
  }
}

function is_active($module) {
    global $prefix, $db, $cache;
    static $save;
    if (is_array($save)) {
        if (isset($save[$module])) return ($save[$module]);
        return 0;
    }elseif (isset($cache->modules) && is_array($cache->modules) && count($cache->modules)) {
        $save = array();
        foreach ($cache->modules as $PN_module => $val) {
            if ($val['active']==0) continue;
        	$save[$PN_module] = $PN_module;
        }
        unset($PN_module, $val);
        if (isset($save[$module])) return ($save[$module]);
        return 0;
    }
    $sql = "SELECT title FROM #__modules WHERE active=1";
    $result = $db->query($sql);
    while ($row = $db->fetchRow($result)) {
        $save[$row[0]] = 1;
    }
    $db->freeResult($result);
    if (isset($save[$module])) return ($save[$module]);
    return 0;
}


function blocks($position) {
	global $pars, $currentlang, $db, $cache, $debug;
	if ($pars->settings['multilingual'] == 1) {
		$querylang = "AND (block_language='$currentlang' OR block_language='')";
	} else {
		$querylang = "";
	}
	$position = pn_safe($position, "en-num");

	if (!isset($cache->blocks) || !is_array($cache->blocks)) {
            $cache->blocks = array();
            $sql = "SELECT * FROM #__blocks WHERE block_active='1' $querylang ORDER BY block_ordering ASC";
            $result = $db->query($sql);
            while($row = $db->fetchRow($result)) {
                  $cache->blocks[$row['block_position']][] = $row;
            }
            $db->freeResult($result);
	}

	$themeSide = ($position=='left' || $position=='right')? 'themeSideBox' : 'themeCenterBox';

	if (!function_exists($themeSide)) {
            $debug->AddMessage(2, "Call to undefined function {$themeSide}()", __FILE__, __LINE__, 2);
	} else {
            if (isset($cache->blocks[$position]) && is_array($cache->blocks[$position]) && count($cache->blocks[$position])) {
               foreach($cache->blocks[$position] as $block)
               {
                       if ($block['block_view']==0 && (is_member() || is_admin())) continue;
                       if ($block['block_view']==2 && (!is_member() || !is_admin())) continue;
                       if ($block['block_view']==3 && (!is_admin())) continue;
                       if ($block['block_view']==4 && (!is_superAdmin())) continue;

                       $data = array("id" => $block['block_id'],
                       "title" => $block['block_title'],
                       "content" => $block['block_content']);
                       if (!empty($block['block_file'])) {
                                  $data['content'] = blockFileInc(pn_safe($block['block_file'], "en-num"));
                       }
                       $themeSide($data);
               }
            }
	}
}

function blockFileInc($blockfile) {
    $blockfile = pn_safe($blockfile, "en-num");
	$file = file_exists(INCLUDE_PATH."blocks/block-".$blockfile.".php");
	if (!$file) {
		$content = _BLOCKPROBLEM;
	} else {
		if(!defined('BLOCK_FILE')) {
		     define('BLOCK_FILE', true);
		}
		$content = null;
		include(INCLUDE_PATH."blocks/block-".$blockfile.".php");
	}
	if (empty($content)) {
		$content = _BLOCKPROBLEM2;
	}
    return $content;
}

function message_box() {
	global $prefix, $multilingual, $currentlang, $db, $admin_file;
	if ($multilingual == 1) {
		$querylang = "AND (mlanguage='$currentlang' OR mlanguage='')";
	} else {
		$querylang = "";
	}
	$result = $db->query("SELECT mid, title, content, date, expire, view FROM ".$prefix."_message WHERE active='1' $querylang");
	if ($numrows = $db->numRows($result) == 0) {
		return;
	} else {
		while ($row = $db->fetchRow($result)) {
			$mid = intval($row['mid']);
			$title = filter($row['title'], "nohtml");
			$content = filter($row['content']);
			$mdate = $row['date'];
			$expire = intval($row['expire']);
			$view = intval($row['view']);
			if (!empty($title) && !empty($content)) {
				if ($view==2 && (is_member() || is_admin())) continue;
				if ($view==3 && (!is_member() || !is_admin())) continue;
				if ($view==4 && !is_admin()) continue;
				if ($expire == 0) {
					$remain = _UNLIMITED;
				} else {
					$etime = (($mdate+$expire)-time())/3600;
					$etime = (int) $etime;
					if ($etime < 1) {
						$remain = _EXPIRELESSHOUR;
					} else {
						$remain = ""._EXPIREIN." $etime "._HOURS."";
					}
				}
				OpenTable($title);
				echo $content;
				if (is_admin()) {
					echo "<br><br><center>[ $remain - <a href=\"".$admin_file.".php?op=editmsg&amp;mid=$mid\">"._EDIT."</a> ]</center>";
				}
				CloseTable();
				if ($expire != 0) {
					$past = time()-$expire;
					if ($mdate < $past) {
						$db->query("UPDATE ".$prefix."_message SET active='0' WHERE mid='$mid'");
					}
				}
			}
		}
        $db->freeResult($result);
	}
}

function online() {
	global $prefix, $db;
	$ip = get_ip();
	if (is_member()) {
	        $uname = is_member('data');
	        $uname = $uname['member_name'];
	        $guest = 0;
	} else {
	        $uname = $ip;
	        $guest = 1;
	}
	$past = time()-3600;
 	$sql = "DELETE FROM ".$prefix."_session WHERE time < '$past'";
 	$db->query($sql);
 	$sql = "SELECT time FROM ".$prefix."_session WHERE uname='".addslashes($uname)."'";
 	$result = $db->query($sql);
 	$ctime = time();
	if (!empty($uname)) {
	        $uname = substr($uname, 0,25);
	        $row = $db->fetchRow($result);
	        if ($row) {
                        $db->query("UPDATE ".$prefix."_session SET uname='".addslashes($uname)."', time='$ctime', host_addr='$ip', guest='$guest' WHERE uname='".addslashes($uname)."'");
	        } else {
                        $db->query("INSERT INTO ".$prefix."_session (uname, time, host_addr, guest) VALUES ('".addslashes($uname)."', '$ctime', '$ip', '$guest')");
	        }
	}
	$db->freeResult($result);
}

function selectlanguage() {
	global $useflags, $currentlang;
	if ($useflags == 1) {
		$title = _SELECTLANGUAGE;
		$content = "<center><font class=\"content\">"._SELECTGUILANG."<br><br>";
		$langdir = dir("language");
		while($func=$langdir->read()) {
			if(substr($func, 0, 5) == "lang-") {
				$menulist .= "$func ";
			}
		}
		closedir($langdir->handle);
		$menulist = explode(" ", $menulist);
		sort($menulist);
		for ($i=0; $i < sizeof($menulist); $i++) {
			if($menulist[$i]!="") {
				$tl = str_replace("lang-","",$menulist[$i]);
				$tl = str_replace(".php","",$tl);
				$altlang = ucfirst($tl);
				$content .= "<a href=\"index.php?newlang=".$tl."\"><img src=\"images/language/flag-".$tl.".png\" border=\"0\" alt=\"$altlang\" title=\"$altlang\" hspace=\"3\" vspace=\"3\"></a> ";
			}
		}
		$content .= "</font></center>";
		themesidebox($title, $content);
	} else {
		$title = _SELECTLANGUAGE;
		$content = "<center><font class=\"content\">"._SELECTGUILANG."<br><br></font>";
		$content .= "<form action=\"index.php\" method=\"get\"><select name=\"newlanguage\" onChange=\"top.location.href=this.options[this.selectedIndex].value\">";
		$handle=opendir('language');
		$languageslist = "";
		while ($file = readdir($handle)) {
			if (preg_match("/^lang\-(.+)\.php/", $file, $matches)) {
				$langFound = $matches[1];
				$languageslist .= "$langFound ";
			}
		}
		closedir($handle);
		$languageslist = explode(" ", $languageslist);
		sort($languageslist);
		for ($i=0; $i < sizeof($languageslist); $i++) {
			if($languageslist[$i]!="") {
				$content .= "<option value=\"index.php?newlang=$languageslist[$i]\" ";
				if($languageslist[$i]==$currentlang) $content .= " selected";
				$content .= ">".ucfirst($languageslist[$i])."</option>\n";
			}
		}
		$content .= "</select></form></center>";
		themesidebox($title, $content);
	}
}

function ultramode() {
	global $prefix, $db;
	$ultra = INCLUDE_PATH."ultramode.txt";
	$file = fopen($ultra, "w");
	fwrite($file, "General purpose self-explanatory file with news headlines\n");
	$sql = "SELECT c.*, cat.* FROM ".$prefix."_content c
           LEFT JOIN ".$prefix."_categories cat ON (cat.cat_id = c.content_category) WHERE c.content_approve = '1' ORDER BY c.content_date DESC LIMIT 0,10";
	$result = $db->query($sql);
	while ($row = $db->fetchRow($result)) {
		$rsid = intval($row['content_id']);
		$rtitle = filter($row['content_title'], "nohtml");
		$rtime = $row['content_date'];
		$rhometext = filter(stripslashes($row['content_text']), "nohtml");
		$rtags = filter($row['content_tags'], "nohtml");
		$topictext = filter($row['cat_name'], "nohtml");
		$content = "%%\n".$rtitle."\n/modules.php?name=Content&amp;id=".$rsid.'-'.pn_urlencode($rtitle, true)."\n".$rtime."\n".$rtags."\n".$topictext."\n";
		fwrite($file, $content);
	}
	fclose($file);
	$db->freeResult($result);
}

function FixQuotes ($what = "") {
	while (stristr($what, "\\\\'")) {
		$what = str_replace("\\\\'","'",$what);
	}
	return $what;
}

/*********************************************************/
/* text filter                                           */
/*********************************************************/

function check_words($Message) {
    global $CensorList, $AllowableHTML;
	include(INCLUDE_PATH."configuration.php");
	$CensorMode = 3;  # فيلتر كردن در هركجاي متن
	$CensorReplace = "****";
	$EditedMessage = $Message;
	if ($CensorMode != 0) {
		if (is_array($CensorList)) {
			$Replace = $CensorReplace;
			if ($CensorMode == 1) {
				for ($i = 0; $i < count($CensorList); $i++) {
					$EditedMessage = eregi_replace("$CensorList[$i]([^a-zA-Z0-9])","$Replace\\1",$EditedMessage);
				}
			} elseif ($CensorMode == 2) {
				for ($i = 0; $i < count($CensorList); $i++) {
					$EditedMessage = eregi_replace("(^|[^[:alnum:]])$CensorList[$i]","\\1$Replace",$EditedMessage);
				}
			} elseif ($CensorMode == 3) {
				for ($i = 0; $i < count($CensorList); $i++) {
					$EditedMessage = eregi_replace("$CensorList[$i]","$Replace",$EditedMessage);
				}
			}
		}
	}
	return ($EditedMessage);
}

function delQuotes($string){
	/* no recursive function to add quote to an HTML tag if needed */
	/* and delete duplicate spaces between attribs. */
	$tmp="";    # string buffer
	$result=""; # result string
	$i=0;
	$attrib=-1; # Are us in an HTML attrib ?   -1: no attrib   0: name of the attrib   1: value of the atrib
	$quote=0;   # Is a string quote delimited opened ? 0=no, 1=yes
	$len = strlen($string);
	while ($i<$len) {
		switch($string[$i]) { # What car is it in the buffer ?
		case "\"": #"       # a quote.
		if ($quote==0) {
			$quote=1;
		} else {
			$quote=0;
			if (($attrib>0) && ($tmp != "")) { $result .= "=\"$tmp\""; }
			$tmp="";
			$attrib=-1;
		}
		break;
		case "=":           # an equal - attrib delimiter
		if ($quote==0) {  # Is it found in a string ?
		$attrib=1;
		if ($tmp!="") $result.=" $tmp";
		$tmp="";
		} else $tmp .= '=';
		break;
		case " ":           # a blank ?
		if ($attrib>0) {  # add it to the string, if one opened.
		$tmp .= $string[$i];
		}
		break;
		default:            # Other
		if ($attrib<0)    # If we weren't in an attrib, set attrib to 0
		$attrib=0;
		$tmp .= $string[$i];
		break;
		}
		$i++;
	}
	if (($quote!=0) && ($tmp != "")) {
		if ($attrib==1) $result .= "=";
		/* If it is the value of an atrib, add the '=' */
		$result .= "\"$tmp\"";  /* Add quote if needed (the reason of the function ;-) */
	}
	return $result;
}

function check_html($str, $strip="") {
	/* The core of this code has been lifted from phpslash */
	/* which is licenced under the GPL. */
	include(INCLUDE_PATH."configuration.php");
	if ($strip == "nohtml")
	$AllowableHTML=array('');
	$str = stripslashes($str);
	$str = eregi_replace("<[[:space:]]*([^>]*)[[:space:]]*>",'<\\1>', $str);
	// Delete all spaces from html tags .
	$str = eregi_replace("<a[^>]*href[[:space:]]*=[[:space:]]*\"?[[:space:]]*([^\" >]*)[[:space:]]*\"?[^>]*>",'<a href="\\1">', $str);
	// Delete all attribs from Anchor, except an href, double quoted.
	$str = eregi_replace("<[[:space:]]* img[[:space:]]*([^>]*)[[:space:]]*>", '', $str);
	// Delete all img tags
	$str = eregi_replace("<a[^>]*href[[:space:]]*=[[:space:]]*\"?javascript[[:punct:]]*\"?[^>]*>", '', $str);
	// Delete javascript code from a href tags -- Zhen-Xjell @ http://nukecops.com
	$tmp = "";
	while (ereg("<(/?[[:alpha:]]*)[[:space:]]*([^>]*)>",$str,$reg)) {
		$i = strpos($str,$reg[0]);
		$l = strlen($reg[0]);
		if ($reg[1][0] == "/") $tag = strtolower(substr($reg[1],1));
		else $tag = strtolower($reg[1]);
		if (isset($AllowableHTML[$tag]) && $a = $AllowableHTML[$tag])
		if ($reg[1][0] == "/") $tag = "</$tag>";
		elseif (($a == 1) || ($reg[2] == "")) $tag = "<$tag>";
		else {
			# Place here the double quote fix function.
			$attrb_list=delQuotes($reg[2]);
			// A VER
			//$attrb_list = ereg_replace("&","&amp;",$attrb_list);
			$tag = "<$tag" . $attrb_list . ">";
		} # Attribs in tag allowed
		else $tag = "";
		$tmp .= substr($str,0,$i) . $tag;
		$str = substr($str,$i+$l);
	}
	$str = $tmp . $str;
	return $str;
	exit;
	/* Squash PHP tags unconditionally */
	$str = ereg_replace("<\?","",$str);
	return $str;
}

function filter_text($Message, $strip="") {
	global $EditedMessage;
	check_words($Message);
	$EditedMessage=check_html($EditedMessage, $strip);
	return ($EditedMessage);
}

function filter($what, $strip="", $save="", $type="") {
	if ($strip == "nohtml") {
	   	$what = check_html($what, $strip);
	   	$what = htmlentities(trim($what), ENT_QUOTES, "UTF-8");
		// If the variable $what doesn't comes from a preview screen should be converted
		if ($type != "preview" AND $save != 1) {
		  	$what = html_entity_decode($what, ENT_QUOTES, "UTF-8");
		}
	}
	if ($save == 1) {
		$what = check_words($what);
		$what = check_html($what, $strip);
		$what = addslashes($what);
	} else {
		$what = stripslashes(FixQuotes($what));
		$what = check_words($what);
		$what = check_html($what, $strip);
	}
	return($what);
}

function get_author($aid) {
	global $prefix, $db;
    static $users;
    if (isset($users[$aid]) AND is_array($users[$aid])) {
        $row = $users[$aid];
    } else {
        $sql = "SELECT url, email FROM ".$prefix."_authors WHERE aid='$aid'";
        $result = $db->query($sql);
        $row = $db->fetchRow($result);
        $users[$aid] = $row;
        $db->freeResult($result);
    }
	$aidurl = filter($row['url'], "nohtml");
	$aidmail = filter($row['email'], "nohtml");
    if (isset($aidurl) && $aidurl != "http://") {
        $aid = "<a href=\"".$aidurl."\">$aid</a>";
    } elseif (isset($aidmail)) {
        $aid = "<a href=\"mailto:".$aidmail."\">$aid</a>";
    } else {
        $aid = $aid;
    }
    return $aid;
}

$ThemeSel = get_theme();
include_once(INCLUDE_PATH."themes/$ThemeSel/theme.php");

if(!function_exists("title")):
    function title($text) {
    	OpenTable();
    	echo "<center><span class=\"pars_title\"><strong>$text</strong></span></center>";
    	CloseTable();
    }
endif;

if(!function_exists("themeCenterBox")):
   function themeCenterBox($b) {
	    OpenTable($b['title']);
	    echo $b['content'];
	    CloseTable();
   }
endif;

function get_theme() {
        global $memberData, $pars, $ThemeSel;
        static $ThemeSelSave;
        if (isset($ThemeSelSave) && !empty($ThemeSelSave)) return $ThemeSelSave;
        $ThemeSel = $pars->settings['Default_Theme'];
        if (is_member() && $pars->settings['overwrite_theme']==1) {
                 $memberData = is_member('data');
                 $memberData['member_theme'] = pn_safe($memberData['member_theme'], "en-num");
                 if (file_exists(INCLUDE_PATH."themes/".$memberData['member_theme']."/theme.php") && !empty($memberData['member_theme'])) {
                         $ThemeSel = $memberData['member_theme'];
                 }
        }
        $ThemeSelSave = $ThemeSel;
        return $ThemeSelSave;
}

function removecrlf($str) {
	// Function for Security Fix by Ulf Harnhammar, VSU Security 2002
	// Looks like I don't have so bad track record of security reports as Ulf believes
	// He decided to not contact me, but I'm always here, digging on the net
	return strtr($str, "\015\012", ' ');
}

function validate_mail($email) {
     if(strlen($email) < 7 || !eregi("^[_\.0-9a-z-]+@([0-9a-z][0-9a-z-]+\.)+[a-z]{2,6}$",$email)) {
          OpenTable();
          echo _ERRORINVEMAIL;
          CloseTable();
          die();
     } else {
          return $email;
     }
}

function ads($position) {
	global $db, $Pras;
	$position = pn_safe($position, "en-num");
	$numrows = $db->numRows("SELECT * FROM #__banners_positions WHERE position_name='$position'", true);
	if ($numrows <= 0) {
		return NULL;
	}
	$ads = NULL;
	$sql = "SELECT * FROM #__banners WHERE banner_position='$position' AND banner_active='1' AND banner_date>NOW() ORDER BY banner_id DESC";
	$result = $db->query($sql);
    while($row = $db->fetchRow($result)) {
	    $db->query("UPDATE `#__banners` SET `banner_hits`=`banner_hits`+1 WHERE `banner_id`='".$row['banner_id']."' LIMIT 1");
        if ($row['banner_type']==1) {
		       $ads .= "<center id='pars_ads_{$position} item-{$row['banner_id']}'><a href=\"index.php?ads_click=".intval($row['banner_id'])."\" target=\"_blank\"><img src=\"{$row['banner_file']}\" width=\"{$row['banner_width']}\" height=\"{$row['banner_height']}\" border=\"0\" alt=\"{$row['banner_title']}\" title=\"{$row['banner_title']}\"></a></center>\n";
        } elseif ($row['banner_type']==2) {
		       $ads .= "<center id='pars_ads_{$position} item-{$row['banner_id']}'><OBJECT classid=\"clsid:D27CDB6E-AE6D-11cf-96B8-444553540000\" "
				."codebase=\"http://download.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,40,0\" "
				."WIDTH=\"{$row['banner_width']}\" HEIGHT=\"{$row['banner_height']}\" id=\"{$row['banner_id']}\">"
				."<PARAM NAME=movie VALUE=\"{$row['banner_file']}\">"
				."<PARAM NAME=quality VALUE=high>"
				."<EMBED src=\"{$row['banner_file']}\" quality=high WIDTH=\"{$row['banner_width']}\" HEIGHT=\"{$row['banner_height']}\" "
				."NAME=\"{$row['banner_id']}\" ALIGN=\"\" TYPE=\"application/x-shockwave-flash\" "
				."PLUGINSPAGE=\"http://www.macromedia.com/go/getflashplayer\">"
				."</EMBED>"
				."</OBJECT></center>\n";
        } elseif ($row['banner_type']==3) {
		        $ads .= "<center id='pars_ads_{$position} item-{$row['banner_id']}'>{$row['banner_code']}</center>\n";
		        $ads  = pn_str_replace('{PN_ADS_URL}', "index.php?ads_click=".intval($row['banner_id']), $ads);
        }
    }
	return $ads;
}

function redir($content) {
	global $Pras;
	unset($location);
	$content = filter($content);
	$links = array();
	$hrefs = array();
	$pos = 0;
	while (!(($pos = strpos($content,"<",$pos)) === false)) {
		$pos++;
		$endpos = strpos($content,">",$pos);
		$tag = substr($content,$pos,$endpos-$pos);
		$tag = trim($tag);
		if (isset($location)) {
			if (!strcasecmp(strtok($tag," "),"/A")) {
				$link = substr($content,$linkpos,$pos-1-$linkpos);
				$links[] = $link;
				$hrefs[] = $location;
				unset($location);
			}
			$pos = $endpos+1;
		} else {
			if (!strcasecmp(strtok($tag," "),"A")) {
				if (eregi("HREF[ \t\n\r\v]*=[ \t\n\r\v]*\"([^\"]*)\"",$tag,$regs));
				else if (eregi("HREF[ \t\n\r\v]*=[ \t\n\r\v]*([^ \t\n\r\v]*)",$tag,$regs));
				else $regs[1] = "";
				if ($regs[1]) {
					$location = $regs[1];
				}
				$pos = $endpos+1;
				$linkpos = $pos;
			} else {
				$pos = $endpos+1;
			}
		}
	}
	for ($i=0; $i<sizeof($hrefs); $i++) {
		$url = urlencode($hrefs[$i]);
		$content = str_replace("<a href=\"$hrefs[$i]\">", "<a href=\"{$Pras->settings['siteurl']}/index.php?url=$url\" target=\"_blank\">", $content);
	}
	return($content);
}

/**
 * Language function
 */
function pn_l($text, $key, $value) {
     $key = array_map("trim", explode("~", $key));
     $value = array_map("trim", explode("~", $value));
	 return str_replace($key, $value, $text);
}

function escapeHex($string) {
    $return = '';
    for ($x=0; $x < strlen($string); $x++) {
            $return .= '%' . bin2hex($string[$x]);
    }
    return $return;
}

function escapeHexEntity($string) {
    $return = '';
    for ($x=0; $x < strlen($string); $x++) {
            $return .= '&#x' . bin2hex($string[$x]) . ';';
    }
    return $return;
}

/**
 * Checks for the length of a string, mb strings accounted for
 *
 * @param string The string to check the length of.
 * @return int The length of the string.
 */
function pn_strlen($string)
{
    $charset = "utf-8";

    $string = preg_replace("#&\#([0-9]+);#", "-", $string);

    if(strtolower($charset) == "utf-8")
    {
        // Get rid of any excess RTL and LTR override for they are the workings of the devil
        $string = str_replace(dec_to_utf8(8238), "", $string);
        $string = str_replace(dec_to_utf8(8237), "", $string);

        // Remove dodgy whitespaces
        $string = str_replace(chr(0xCA), "", $string);
    }
	$string = trim($string);

    if(function_exists("mb_strlen"))
    {
        $string_length = mb_strlen($string);
    }
    else
    {
        $string_length = strlen($string);
    }

    return $string_length;
}

/**
 * Cuts a string at a specified point, mb strings accounted for
 *
 * @param string The string to cut.
 * @param int Where to cut
 * @param int (optional) How much to cut
 * @param bool (optional) Properly handle HTML entities?
 * @return int The cut part of the string.
 */
function pn_substr($string, $start, $length="", $handle_entities = false)
{
	if($handle_entities)
	{
		$string = unhtmlentities($string);
	}
	if(function_exists("mb_substr"))
	{
		if($length != "")
		{
			$cut_string = mb_substr($string, $start, $length);
		}
		else
		{
			$cut_string = mb_substr($string, $start);
		}
	}
	else
	{
		if($length != "")
		{
			$cut_string = substr($string, $start, $length);
		}
		else
		{
			$cut_string = substr($string, $start);
		}
	}

	if($handle_entities)
	{
		$cut_string = htmlspecialchars_uni($cut_string);
	}
	return $cut_string;
}

/**
 * lowers the case of a string, mb strings accounted for
 *
 * @param string The string to lower.
 * @return int The lowered string.
 */
function pn_strtolower($string)
{
	if(function_exists("mb_strtolower"))
	{
		$string = mb_strtolower($string);
	}
	else
	{
		$string = strtolower($string);
	}

	return $string;
}

/**
 * Finds a needle in a haystack and returns it position, mb strings accounted for
 *
 * @param string String to look in (haystack)
 * @param string What to look for (needle)
 * @param int (optional) How much to offset
 * @return int false on needle not found, integer position if found
 */
function pn_strpos($haystack, $needle, $offset=0)
{
	if($needle == '')
	{
		return false;
	}

	if(function_exists("mb_strpos"))
	{
		$position = mb_strpos($haystack, $needle, $offset);
	}
	else
	{
		$position = strpos($haystack, $needle, $offset);
	}

	return $position;
}

/**
 * ups the case of a string, mb strings accounted for
 *
 * @param string The string to up.
 * @return int The uped string.
 */
function pn_strtoupper($string)
{
	if(function_exists("mb_strtoupper"))
	{
		$string = mb_strtoupper($string);
	}
	else
	{
		$string = strtoupper($string);
	}

	return $string;
}

/**
 * Returns any html entities to their original character
 *
 * @param string The string to un-htmlentitize.
 * @return int The un-htmlentitied' string.
 */
function unhtmlentities($string)
{
	// Replace numeric entities
	$string = preg_replace('~&#x([0-9a-f]+);~ei', 'unichr(hexdec("\\1"))', $string);
	$string = preg_replace('~&#([0-9]+);~e', 'unichr("\\1")', $string);

	// Replace literal entities
	$trans_tbl = get_html_translation_table(HTML_ENTITIES);
	$trans_tbl = array_flip($trans_tbl);

	return strtr($string, $trans_tbl);
}

/**
 * Custom chmod function to fix problems with hosts who's server configurations screw up umasks
 *
 * @param string The file to chmod
 * @param string The mode to chmod(i.e. 0666)
 */
function pn_chmod($file, $mode)
{
	// Passing $mode as an octal number causes strlen and substr to return incorrect values. Instead pass as a string
	if(substr($mode, 0, 1) != '0' || strlen($mode) !== 4)
	{
		return false;
	}
	$old_umask = umask(0);

	// We convert the octal string to a decimal number because passing a octal string doesn't work with chmod
	// and type casting subsequently removes the prepended 0 which is needed for octal numbers
	$result = chmod($file, octdec($mode));
	umask($old_umask);
	return $result;
}

/**
 * Converts a decimal reference of a character to its UTF-8 equivalent
 * (Code by Anne van Kesteren, http://annevankesteren.nl/2005/05/character-references)
 *
 * @param string Decimal value of a character reference
 */
function dec_to_utf8($src)
{
	$dest = '';

	if($src < 0)
	{
  		return false;
 	}
	elseif($src <= 0x007f)
	{
		$dest .= chr($src);
	}
	elseif($src <= 0x07ff)
	{
		$dest .= chr(0xc0 | ($src >> 6));
		$dest .= chr(0x80 | ($src & 0x003f));
	}
	elseif($src <= 0xffff)
	{
		$dest .= chr(0xe0 | ($src >> 12));
		$dest .= chr(0x80 | (($src >> 6) & 0x003f));
		$dest .= chr(0x80 | ($src & 0x003f));
	}
	elseif($src <= 0x10ffff)
	{
		$dest .= chr(0xf0 | ($src >> 18));
		$dest .= chr(0x80 | (($src >> 12) & 0x3f));
		$dest .= chr(0x80 | (($src >> 6) & 0x3f));
		$dest .= chr(0x80 | ($src & 0x3f));
	}
	else
	{
		// Out of range
		return false;
	}

	return $dest;
}

/**
 * Fetch the friendly size (GB, MB, KB, B) for a specified file size.
 *
 * @param int The size in bytes
 * @return string The friendly file size
 */
function get_friendly_size($size)
{
	global $lang;

	if(!is_numeric($size))
	{
		return false;
	}

	// Yottabyte (1024 Zettabytes)
	if($size >= 1208925819614629174706176)
	{
		$size = pn_number_format(round(($size / 1208925819614629174706176), 2))." YB";
	}
	// Zetabyte (1024 Exabytes)
	elseif($size >= 1180591620717411303424)
	{
		$size = pn_number_format(round(($size / 1180591620717411303424), 2))." ZB";
	}
	// Exabyte (1024 Petabytes)
	elseif($size >= 1152921504606846976)
	{
		$size = pn_number_format(round(($size / 1152921504606846976), 2))." EB";
	}
	// Petabyte (1024 Terabytes)
	elseif($size >= 1125899906842624)
	{
		$size = pn_number_format(round(($size / 1125899906842624), 2))." PB";
	}
	// Terabyte (1024 Gigabytes)
	elseif($size >= 1099511627776)
	{
		$size = pn_number_format(round(($size / 1099511627776), 2))." TB";
	}
	// Gigabyte (1024 Megabytes)
	elseif($size >= 1073741824)
	{
		$size = pn_number_format(round(($size / 1073741824), 2))." GB";
	}
	// Megabyte (1024 Kilobytes)
	elseif($size >= 1048576)
	{
		$size = pn_number_format(round(($size / 1048576), 2))." MB";
	}
	// Kilobyte (1024 bytes)
	elseif($size >= 1024)
	{
		$size = pn_number_format(round(($size / 1024), 2))." KB";
	}
	elseif($size == 0)
	{
		$size = "0 bytes";
	}
	else
	{
		$size = pn_number_format($size)." bytes";
	}

	return $size;
}

/**
 * Custom function for formatting numbers.
 *
 * @param int The number to format.
 * @return int The formatted number.
 */
function pn_number_format($number)
{
	if($number == "-")
	{
		return $number;
	}

	if(is_int($number))
	{
		return number_format($number, 0, '.', ',');
	}
	else
	{
		$parts = explode('.', $number);

		if(isset($parts[1]))
		{
			$decimals = pn_strlen($parts[1]);
		}
		else
		{
			$decimals = 0;
		}

		return number_format((double)$number, $decimals, '.', ',');
	}
}

function parsNuke_Editor($name, $value='', $class='', $attributes='', $type='class', $config='') {
    global $pars;
    if ($pars->settings['nuke_editor']==0)
    return "<textarea name=\"{$name}\" class=\"{$class}\"{$attributes}>{$value}</textarea>";

    set_head('<script type="text/javascript" src="includes/ckeditor/ckeditor.js"></script>');
    $class = !empty($class)? " ".$class : "";
    $attributes = !empty($attributes)? " ".$attributes : "";
    if ($type=='class') {
        return "<textarea name=\"{$name}\" class=\"ckeditor{$class}\"{$attributes}>{$value}</textarea>";
    } else {
        if (empty($config))
        $config  = "{\"toolbar\": [ [ \"FontSize\", \"Bold\", \"Italic\", \"TextColor\", \"-\", \"JustifyLeft\", \"JustifyCenter\", \"JustifyRight\", \"-\", \"Link\", \"Image\", \"Smiley\" ] ] }";
        $html  = "<textarea name=\"{$name}\" id=\"{$name}{$class}\"{$attributes}>{$value}</textarea>\n";
        $html .= "<script type=\"text/javascript\">\n";
        $html .= "//<![CDATA[\n";
        $html .= "CKEDITOR.replace('{$name}', $config);\n";
        $html .= "//]]>\n";
        $html .= "</script>\n";
        return $html;
    }
}

if (!function_exists("themeMail")) {
    function themeMail($Subject, $Date, $SiteName, $SiteUrl, $Email, $Body) {
         $Html  = "<html dir=\"rtl\">\n";
         $Html .= "<head>\n";
         $Html .= "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">\n";
         $Html .= "<meta http-equiv=\"Content-Language\" content=\"fa\">\n";
         $Html .= "<style type=\"text/css\">\n";
         $Html .= "body,table {background:White;font-family:Tahoma;font-size:9pt;color:Black}\n";
         $Html .= "</style>\n";
         $Html .= "</head>\n";
         $Html .= "<body>\n";
         $Html .= "<table border=\"0\" width=\"100%\" height=\"85%\">\n";
         $Html .= "<tr>\n";
         $Html .= "<td align=\"center\">\n";
         $Html .= "<table border=\"0\" width=\"478\" dir=\"rtl\" style=\"border-collapse:collapse;border:1px solid #666666;background-color:#EEEEEE;\">\n";
         $Html .= "<tr>\n";
         $Html .= "<td style=\"padding: 10px\">\n";
         $Html .= "موضوع نامه: <b>{$Subject}</b><br>\n";
         $Html .= "تاريخ ارسال: <b>{$Date}</b><br>\n";
         $Html .= "ارسال شده از طرف: <b>{$Email}</b><br>\n";
         $Html .= "سايت ارسال كننده: <b><a href=\"{$SiteUrl}\" target=\"_blank\">{$SiteName}</a></b><br>\n";
         $Html .= "متن نامه: {$Body}\n";
         $Html .= "</td>\n";
         $Html .= "</tr>\n";
         $Html .= "</table>\n";
         $Html .= "<br><center><a href=\"http://parsnuke.com\" target=\"_blank\"><img src=\"{$SiteUrl}/images/powered/powered.png\" border=\"0\"></a></center>\n";
         $Html .= "</td>\n";
         $Html .= "</tr>\n";
         $Html .= "</table>\n";
         $Html .= "</body>\n";
         $Html .= "</html>";
         return $Html;
    }
}

function pn_mail($To, $Subject, $Body, $From) {
	global $pars;
	$MailHeader  = 'MIME-Version: 1.0' . "\r\n";
	$MailHeader .= 'Content-type: text/html; charset=UTF-8' . "\r\n";
    $MailHeader .= 'From: '.$From . "\r\n"; // Sender's Email Address
	$MailHeader .= 'Return-Path: '.$From.' <'.$From.'> /n'; // Indicates Return-path
	$MailHeader .= 'Reply-To: '. $From.' <'.$From.'> /n'; // Reply-to Address
	$MailHeader .= 'X-Mailer: PHP/' . phpversion(); // For X-Mailer
    $Body = themeMail($Subject, jdate("l j F Y ساعت H:i:s"), $pars->settings['sitename'], $pars->settings['siteurl'], $From, $Body);
    if(@mail($To, $Subject, $Body, $MailHeader))
    return true;
    return false;
}

// Custom preg-match function
function preg_check($expression, $value) {
	if (!is_array($value)) {
		return preg_match($expression, $value);
	} else {
		return false;
	}
}

function set_title($title="", $type="add") {
	global $pars;
	$pars->theme['page_title'] = $type=="add"? $pars->theme['page_title'].' &raquo; '.$title : $title;
}

function set_meta($name, $addition="") {
	global $pars;
	if(isset($pars->theme['page_meta'][$name])){
		$pars->theme['page_meta'][$name] .= ' , '.$addition;
	}else{
		$pars->theme['page_meta'][$name] = $addition;
	}
}

function set_head($tag="") {
	global $pars;
	if(!stristr($pars->theme['head_tags'], $tag)){
		$pars->theme['head_tags'] .= $tag."\n";
	}
}

function set_footer($tag="") {
	global $pars;
	if(!stristr($pars->theme['footer_tags'], $tag)){
		$pars->theme['footer_tags'] .= $tag."\n";
	}
}

function parsNuke_handle_output($output) {
	global $pars, $debug, $cache;
    $pars->theme['vars']['THEME'] = "themes/".get_theme();
	if (!empty($pars->theme['footer_tags']))
    {
		$output = preg_replace("#</body>#i", $pars->theme['footer_tags']."</body>", $output, 1);
	}
	if (!empty($pars->theme['head_tags']))
    {
		$output = preg_replace("#</head>#i", $pars->theme['head_tags']."</head>", $output, 1);
	}
	if (!empty($pars->theme['page_title']))
    {
		$output = preg_replace("#<title>.*</title>#i", "<title>".$pars->theme['page_title']."</title>", $output, 1);
	}
	if (is_array($pars->theme['page_meta']) && count($pars->theme['page_meta']))
    {
		foreach ($pars->theme['page_meta'] as $name => $content)
        {
			$output = preg_replace("#<meta (http-equiv|name)=['\"]{$name}['\"] content=['\"].*['\"](| /|/)>#i", "<meta \\1=\"".$name."\" content=\"".$content."\" />", $output, 1);
		}
	}
	if (isset($pars->theme['vars']) && is_array($pars->theme['vars']) && count($pars->theme['vars']))
	{
		foreach ($pars->theme['vars'] as $key => $val)
	    {
			if (empty($key) || is_array($key) || is_array($val)) continue;
			$output = pn_str_replace("{PN_".$key."}", $val, $output);
		}
	}
    if ($pars->settings['seo']==1 && !defined('ADMIN_FILE'))
    {
		get_modules();
		foreach ($cache->modules as $PN_module => $val) {
	  	  	if ($val['active']==0) continue;
	   		if(file_exists(INCLUDE_PATH."modules/{$PN_module}/{$PN_module}.seo.php")){
			     include(INCLUDE_PATH."modules/{$PN_module}/{$PN_module}.seo.php");
	   		}
		}
		unset($PN_module, $val);
    }

	if (is_array($pars->urls) && count($pars->urls))
    {
        foreach ($pars->urls as $url => $seo)
        {
			  $output = preg_replace($url, $seo, $output);
		}
	}

    if (is_admin())
    $output = $debug->Output() . $output;
    unset($debug);

    // check if the browser accepts gzip encoding. Most do, but just in case
    /*if (strpos($_SERVER['HTTP_ACCEPT_ENCODING'], 'gzip')!==FALSE && function_exists("gzencode") && extension_loaded('zlib') && $pars->settings['gzipoutput']==1)
    {
        $output = gzencode($output);
        Header('Content-Encoding: gzip');
    }*/
	return $output;
}


function ParsNuke_head() {
	global $prefix, $db, $index, $name, $admin, $commercial_license;
	include(INCLUDE_PATH."includes/header.php");
}

function get_header() {
    ob_start();
	online();
	themeHeader();
	include(INCLUDE_PATH."includes/counter.php");
	if(defined('HOME_FILE')) {
		message_box();
		blocks("top");
	}
}

function get_footer() {
	global $prefix, $db, $index, $name, $admin, $commercial_license;
	include(INCLUDE_PATH."includes/footer.php");

	if(defined('HOME_FILE')) {
		blocks("bottom");
	}
	if (isset($_REQUEST['name']) AND !empty($_REQUEST['name']) AND file_exists("modules/".$_REQUEST['name']."/copyright.php") AND basename($_SERVER['PHP_SELF']) != "index.php" AND defined('MODULE_FILE')) {
		echo "<div align=\"right\"><a href=\"modules/".$_REQUEST['name']."/copyright.php\" id=\"pn_Copyright\">".str_replace("_", " ", $_REQUEST['name'])." &copy;</a></div>";
	}
	if (basename($_SERVER['PHP_SELF']) != "index.php" AND defined('MODULE_FILE') AND (file_exists(INCLUDE_PATH."modules/$name/admin/panel.php") && is_admin())) {
		OpenTable("مديريت سريع");
		include_once(INCLUDE_PATH."modules/$name/admin/panel.php");
		CloseTable();
	}
	themeFooter();
	if (file_exists(INCLUDE_PATH."includes/custom_files/custom_footer.php")) {
		include_once(INCLUDE_PATH."includes/custom_files/custom_footer.php");
	}

	$content = ob_get_contents();
	ob_end_clean();
	echo parsNuke_handle_output($content);

    parsNuke_ob_end_flush();
	die();
}

function create_captcha($key='IMAN') {
    global $pars;
    switch($pars->settings['captcha']) {
       case '0':
	   return false;
       break;

       case '2':
       if(is_member() || is_admin())
	   return false;
       break;

       case '3':
       if(is_admin())
	   return false;
       break;

       case '4':
       if(!is_admin())
	   return false;
       break;
    }
    $html = "<a href=\"javascript:void(0)\" onclick=\"document.getElementById('pn-captcha').src='modules.php?captcha=yes&key={$key}&rand='+Math.random()\"><img src=\"modules.php?captcha=yes&key={$key}\" id=\"pn-captcha\" width=\"77\" height=\"20\" alt=\"captcha!\" border=\"0\"></a>\n";
    return $html;
}

function validate_captcha($key='IMAN', $captcha) {
    global $pars;
    switch($pars->settings['captcha']) {
       case '0':
	   return true;
       break;

       case '2':
       if(is_member() || is_admin())
	   return true;
       break;

       case '3':
       if(is_admin())
	   return true;
       break;

       case '4':
       if(!is_admin())
	   return true;
       break;
    }

    $key = pn_safe($key, "en-num");
    if(isset($_COOKIE['PARSNUKE_CAPTCHA_'.$key]) && !empty($_COOKIE['PARSNUKE_CAPTCHA_'.$key])) {
          if(md5($captcha) == $_COOKIE['PARSNUKE_CAPTCHA_'.$key]) {
	           return true;
          }
    }
	return false;
}

run_hooks("mainfile.end");

if (isset($pars->input['captcha']) && $pars->request_method=='get') {

	mt_srand ((double)microtime()*1000000);
	$code = mt_rand(100, 999999);
	$key = pn_getParam('key', $pars->input, 'IMAN');
	$key = empty($key)? 'IMAN' : $key;
	setcookie("PARSNUKE_CAPTCHA_".$key, md5($code));

	$ThemeSel = get_theme();
	if (file_exists(INCLUDE_PATH."themes/".$ThemeSel."/images/code_bg.jpg")) {
		$image = ImageCreateFromJPEG(INCLUDE_PATH."themes/".$ThemeSel."/images/code_bg.jpg");
	} else {
		$image = ImageCreateFromJPEG(INCLUDE_PATH."images/code_bg.jpg");
	}
	$text_color = ImageColorAllocate($image, 80, 80, 80);
	Header("Content-type: image/jpeg");
	ImageString ($image, 5, 12, 2, $code, $text_color);
	ImageJPEG($image, '', 75);
	ImageDestroy($image);
	die();

}

?>