<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: index.php 2012-01-28 19:10:21 (Iman92)$
 */

if (!defined('MODULE_FILE')) {
    die ("You can't access this file directly...");
}

$module_name = basename(dirname(__FILE__));
get_lang($module_name);
define('INDEX_FILE', true);
set_title(_UDOWNLOADS);
cache_DownloadsCategories();

function dl_menu() {
    global $module_name;
    OpenTable();
    $ThemeSel = get_theme();
    if (file_exists("themes/$ThemeSel/images/down-logo.gif")) {
	echo "<br><center><a href=\"modules.php?name=$module_name\"><img src=\"themes/$ThemeSel/images/down-logo.gif\" border=\"0\"></a></center><br>";
    } else {
	echo "<br><center><a href=\"modules.php?name=$module_name\"><img src=\"modules/$module_name/images/down-logo.gif\" border=\"0\"></a></center><br>";
    }
    CloseTable();
}

function dl_index() {
    global $module_name, $cache;
    get_header();
    dl_menu();
    OpenTable("موضوعات");
    $t = new table(null, 'dl_index', null, 0, 5);

    foreach($cache->download_categories as $cat) {
           $t->tr();
           $t->td( html::img("includes/upload/categories/".$cat['cat_image']), 'width: 65px' );
           $t->td( html::a(pn_link("name=Downloads&op=categories&catID=".$cat['cat_id']), "<b>{$cat['cat_name']}</b>") . "<br>{$cat['cat_description']}<br><i>{$cat['cat_count']} فايل در اين دسته قرار دارد.</i>", '', 'valign="top"' );
    }

    $t->show();
    CloseTable();
    get_footer();
}

function dl_categories($catID) {
    global $module_name, $cache, $db, $pars;
    $catID = (int) $catID;
    $pageNum = (int) pn_getParam('pageNum', $_GET, 1);
    $pageNum = $pageNum<=0? 1 : $pageNum;
    $limit   = intval($pars->settings['limit_downloads']);
    $offset  = parsNuke_page('SQL',$limit,$pageNum);
    $total   = $db->numRows("SELECT * FROM #__downloads WHERE download_cat='{$catID}' and download_active='1'", true);
    if (!isset($cache->download_categories[$catID]) || $offset>$total) pn_redirect(pn_link("name=Downloads"));
    set_title($cache->download_categories[$catID]['cat_name']);
    get_header();
    dl_menu();

    if ($total <= 0) {
    OpenTable();
    echo pn_message("هيچ فايلي در اين موضوع وجود ندارد.", "info", false);
    CloseTable();
    } else {

    $q = $db->query("SELECT * FROM #__downloads WHERE download_cat='{$catID}' and download_active='1' ORDER BY download_id DESC LIMIT $offset,$limit");
    while($row = $db->fetchRow($q)) {
           OpenTable( html::a(pn_link("name=Downloads&op=view&dlID=".$row['download_id']), $row['download_title']) );
           $row['download_description'] = empty($row['download_description'])? "توضيحي ندارد" : $row['download_description'];
           echo "ارسال شده در ".jdate("l j F Y", strtotime($row['download_date']))."<br>ارسال شده توسط {$row['download_submitter']}<br>{$row['download_totaldl']} بار دانلود شده<br>{$row['download_hits']} بار مشاهده شده";
           CloseTable();
    }

    }

    parsNuke_page($total,$limit,$pageNum,pn_link("name=Downloads&op=categories&catID=".$catID."&"));
    get_footer();
}

function dl_view($dlID) {
    global $module_name, $cache, $db, $pars;
    $dlID = (int) $dlID;
    $q = $db->query("SELECT * FROM #__downloads WHERE download_id='{$dlID}' and download_active='1' limit 1");
    get_header();
    dl_menu();
    OpenTable();

    if ($db->numRows($q) <= 0) {
    set_title("فايل يافت نشد");
    echo pn_message("اين فايل وجود ندارد و يا حذف شده است.", "info", false);
    } else {
    $t = new table(null, 'dl_view', null, 0, 3);

    $row = $db->fetchRow($q);
    $db->query("UPDATE `#__downloads` SET `download_hits`=`download_hits`+1 WHERE `download_id`='".$row['download_id']."' LIMIT 1");
    $row['download_hits']++;
    set_title($row['download_title']);
    $row['download_image'] = empty($row['download_image'])? "modules/{$module_name}/images/Download.gif" : $row['download_image'];
    $row['download_description'] = empty($row['download_description'])? "توضيحي ندارد" : $row['download_description'];
    $row['download_url'] = empty($row['download_url'])? $pars->settings['siteurl'] : $row['download_url'];
    $file_size = @filesize( $row['download_file'] );

    if ($row['download_view']==2 && !is_member() && !is_admin()) $dl_link = false;
    elseif ($row['download_view']==3 && !is_admin()) $dl_link = false;
    else $dl_link = true;

    if ($row['download_view']==2 && !is_member() && !is_admin()) $dl_link2 = "دانلود فقط براي كاربران مجاز است.";
    elseif ($row['download_view']==3 && !is_admin()) $dl_link2 = "دانلود فقط براي مديران مجاز است.";
    else $dl_link2 = html::a(pn_link("name=Downloads&op=download&dlID=".$row['download_id']."&no_gzip=yes"), "دانلود");

    $t->tr();
    $t->td( $dl_link? html::a(pn_link("name=Downloads&op=download&dlID=".$row['download_id']."&no_gzip=yes"), html::img("modules/{$module_name}/images/Download.gif", 'width="60" height="60"'), 'title="دانلود فايل"') : html::img("modules/{$module_name}/images/Download.gif", 'width="60" height="60" title="دانلود فايل فقط براي كاربران"'), 'width: 65px' );
    $t->td(
            "<b>نام</b>: <b>{$row['download_title']}</b><br>"
            .
            "<b>توضيحات</b>: {$row['download_description']}<br>"
            .
            "<b>تاريخ ارسال</b>: ".jdate("l j F Y ساعت H:i", strtotime($row['download_date']))."<br>"
            .
            "<b>ارسال كننده</b>: {$row['download_submitter']}<br>"
            .
            "<b>سايت سازنده</b>: ".html::a($row['download_url'], "مشاهده سايت سازنده", '', '_blank')."<br>"
            .
            "<b>عكس دمو</b>: ".html::a($row['download_image'], "مشاهده عكس دمو", 'id="pn_ajaxBox"')."<br>"
            .
            "<b>حجم فايل</b>: ".get_friendly_size($file_size)."<br>"
            .
            "<b>نسخه فايل</b>: {$row['download_version']}<br>"
            .
            "<b>دفعات مشاهده شده</b>: {$row['download_hits']} بار مشاهده شده<br>"
            .
            "<b>دفعات دانلود فايل</b>: {$row['download_totaldl']} بار دانلود شده<br>"
            .
            "<b>دانلود</b>: ".$dl_link2
            , '', 'valign="top"' );

    $t->show();
    }

    CloseTable();
    if($row['download_comment']==1) {
             title("نظرات اين فايل");
             require_once(INCLUDE_PATH."includes/functions_comments.php");
             pn_commentsShow('download', intval($row['download_id']), "modules.php?name=Downloads&amp;file=comment");
    }
    get_footer();
}

function dl_download($dlID) {
    global $module_name, $cache, $db, $pars;
    $dlID = (int) $dlID;
    $q = $db->query("SELECT * FROM #__downloads WHERE download_id='{$dlID}' and download_active='1' limit 1");

    if ($db->numRows($q) <= 0) {
        get_header();
        dl_menu();
        OpenTable();
        set_title("فايل يافت نشد");
        echo pn_message("اين فايل وجود ندارد و يا حذف شده است.", "info", false);
        CloseTable();
        get_footer();
    } else {
        $row = $db->fetchRow($q);

        if ($row['download_view']==2 && !is_member() && !is_admin()) $dl_link = false;
        elseif ($row['download_view']==3 && !is_admin()) $dl_link = false;
        else $dl_link = true;
        if (!$dl_link) pn_redirect(pn_link("name=Downloads&op=view&dlID=".$row['download_id']));

        $files_max_speed = 0;
        $files_force = 1;

        require_once(INCLUDE_PATH."includes/class_download.php");
        $file = new download ( INCLUDE_PATH . $row['download_file'], "", $files_force, $files_max_speed);

        if (!$file->range)
        $db->query("UPDATE `#__downloads` SET `download_totaldl`=`download_totaldl`+1 WHERE `download_id`='".$row['download_id']."' LIMIT 1");

        update_points("Download");

        $file->download_file();
        die;
    }
}

switch($op) {

    case "categories":
    dl_categories($_GET['catID']);
    break;

    case "view":
    dl_view($_GET['dlID']);
    break;

    case "download":
    dl_download($_GET['dlID']);
    break;

    default:
    dl_index();
    break;

}

?>