<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: index.php 2012-02-01 23:03:48 (Iman92)$
 */

if (!defined('MODULE_FILE')) {
	die ("You can't access this file directly...");
}
$module_name = basename(dirname(__FILE__));

if (is_ajax() && isset($_POST['contact_name'], $_POST['contact_email'], $_POST['contact_message'])) {
     $_POST['contact_name'] = pn_safe($_POST['contact_name'], "showhtml");
     $_POST['contact_email'] = pn_safe($_POST['contact_email'], "_nohtml");
     $_POST['contact_message'] = pn_safe($_POST['contact_message'], "showhtml");
     $_POST['contact_phone'] = pn_safe($_POST['contact_phone'], "en-num");

     $Error = null;
     if (empty($_POST['contact_name'])) {
          $Error .= 'div#nameError,';
     }

     if (!empty($_POST['contact_email']) && !validate_email_format($_POST['contact_email'])) {
          $Error .= 'div#emailError,';
     }

     if (!empty($_POST['contact_phone']) && !is_numeric($_POST['contact_phone'])) {
          $Error .= 'div#phoneError,';
     }

     if (empty($_POST['contact_message'])) {
          $Error .= 'div#messageError,';
     }

     if (!validate_captcha('contact', isset($_POST['security_code'])? $_POST['security_code'] : null)) {
          $Error .= 'div#security_codeError,';
     }

     if (!empty($Error)) {
          $Error = trim($Error, ',');
          echo json_encode(array('Error'=>'yes', 'ErrorDiv'=>$Error));
          die;
     }

     $msg  = "شما از طريق فرم تماس با ما سايت اين پيام را دريافت كرده ايد.<br>";
     $msg .= "نام فرستنده: ".$_POST['contact_name']."<br>";
     $msg .= "ايميل فرستنده: ".$_POST['contact_email']."<br>";
     $msg .= "شماره تماس فرستنده: ".$_POST['contact_phone']."<br>";
     $msg .= "متن پيام:<br>".$_POST['contact_message'];
     if (pn_mail($pars->settings['adminmail'], "تماس از ".$pars->settings['sitename'], $msg, $pars->settings['siteMail'])) {
          $Error = 'div#contact_success';
     } else {
          $Error = 'div#contact_error';
     }

     echo json_encode(array('Error'=>'no', 'MsgDiv'=>$Error));
     pn_unsetcookie('PARSNUKE_CAPTCHA_contact');
     die;
}

get_lang($module_name);
define('INDEX_FILE', true);
set_title(_FEEDBACK);
set_head( html::css("modules/Feedback/styles/default.css", "file") );
set_head( html::js("modules/Feedback/js/js.js", "file") );

get_header();
openTable(_FEEDBACK);
?>
<div id="contact_form">
<form method="post" action="modules.php?name=Feedback" id="contactForm">
<div id="contact_error"><?php echo pn_message(_CONTACT_ERROR, "error", false) ?></div>
<div id="contact_success"><?php echo pn_message(_CONTACT_SUCCESS, "success", false) ?></div>
<table>
  <tr>
    <td style="width: 80px"><label for="name"><b><?php echo _YOURNAME ?>:</b></label></td>
    <td><input type="text" id="name" name="contact_name" /><div class="warning" id="nameError"><?php echo _CONTACT_WARNING_NAME ?></div></td>
  </tr>

  <tr>
    <td><label for="email"><b><?php echo _EMAIL ?>:</b></label></td>
    <td><input type="text" id="email" name="contact_email" dir="ltr" /><div class="warning" id="emailError"><?php echo _CONTACT_WARNING_EMAIL ?></div></td>
  </tr>

  <tr>
    <td><label for="phone"><b><?php echo _PHONE ?>:</b></label></td>
    <td><input type="text" id="phone" name="contact_phone" dir="ltr" /><div class="warning" id="phoneError"><?php echo _CONTACT_WARNING_PHONE ?></div></td>
  </tr>

  <tr>
    <td><label for="message"><b><?php echo _MESSAGE ?>:</b></label></td>
    <td><textarea id="message" name="contact_message"></textarea><div class="warning" id="messageError"><?php echo _CONTACT_WARNING_MESSAGE ?></div></td>
  </tr>
<?php if ($captcha = create_captcha('contact')) {  ?>
  <tr>
    <td><label for="security_code"><b><?php echo _SECURITY_CODE ?>:</b></label></td>
    <td><?php echo $captcha ?><input class="noicon" type="text" id="security_code" name="security_code" style="width:80px" dir="ltr" /><div class="warning" id="security_codeError"><?php echo _CONTACT_WARNING_SECURITY_CODE ?></div></td>
  </tr>
<?php }  ?>
  <tr>
    <td></td>
    <td><input id="send" type="submit" value="<?php echo _SEND ?>" /><div class="pars_smallLoading" id="ajax_loader"></div></td>
  </tr>
</table>
</form>
</div>
<?php
CloseTable();
get_footer();

?>