<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: index.php 2012-01-28 19:10:21 (Iman92)$
 */

if (!defined('MODULE_FILE')) {
	die ("You can't access this file directly...");
}
require_once("mainfile.php");
$module_name = basename(dirname(__FILE__));
set_title("آمار بازديد");

if (isset($year)) {
	$year = intval($year);
}
$ThemeSel = get_theme();

function Stats_Menu() {
	openTable();
    echo '<center>[ '.html::a('modules.php?name=Statistics&amp;op=Browser', 'مرورگر ها').' - '.html::a('modules.php?name=Statistics&amp;op=OS', 'سيستم عامل ها').' - '.html::a('modules.php?name=Statistics&amp;op=Year', 'بازديدهاي ساليانه').' ]</center>';
	closeTable();
}

function Stats_Browser() {
	global $db, $startdate, $cache, $ThemeSel;
    set_title("مرورگرها");
	get_header();
    Stats_Menu();
	openTable();
    if (!isset($cache->statistics_Browser) || !is_array($cache->statistics_Browser) || !count($cache->statistics_Browser)) {
          $cache->statistics_Browser = array();
          $result = $db->query("SELECT * from #__statistics WHERE stat_name LIKE '%Browser-%' order by stat_name desc");
          while ($row = $db->fetchRow($result)) {
                 $cache->statistics_Browser[ $row["stat_name"] ] = $row;
          }
          $db->freeResult($result);
          unset($result, $row);
    }
    $counts = 0;
	foreach ($cache->statistics_Browser as $row) {
             $counts += $row['stat_value'];
	}
    $image = file_exists("themes/".$ThemeSel."/images/lineBar.gif")? "themes/".$ThemeSel."/images/lineBar.gif" : "modules/Statistics/images/bar4.gif";

    $t = new table('pars_table', null, null, 5);
    $t->tr();
    $t->th( "شماره", "width: 50px" );
    $t->th( "نام مرورگر", "width: 200px" );
    $t->th( "نمودار" );
    $t->th( "تعداد", "width: 100px" );

    $i =1;
	foreach ($cache->statistics_Browser as $row) {
             $count = round(100 * $row['stat_value'] / $counts);
             if ($count==0) $count = '0.5';
             $t->tr("class=".odd_even());
             $t->td( Convertnumber2farsi($i), "text-align: center" );
             $t->td( str_replace('Browser-', '', $row['stat_name']), "text-align: left" );
             $t->td( '<div style="background: url('.$image.'); height: 11px; width: '.$count.'%"></div>' );
             $t->td( Convertnumber2farsi($row['stat_value']), "text-align: center" );
             $i++;
	}

    $t->show();
	closeTable();
	get_footer();
}

function Stats_OS() {
	global $db, $startdate, $cache, $ThemeSel;
    set_title("سيستم عامل ها");
	get_header();
    Stats_Menu();
	openTable();
    if (!isset($cache->statistics_OS) || !is_array($cache->statistics_OS) || !count($cache->statistics_OS)) {
          $cache->statistics_OS = array();
          $result = $db->query("SELECT * from #__statistics WHERE stat_name LIKE '%OS-%' order by stat_name desc");
          while ($row = $db->fetchRow($result)) {
                 $cache->statistics_OS[ $row["stat_name"] ] = $row;
          }
          $db->freeResult($result);
          unset($result, $row);
    }
    $counts = 0;
	foreach ($cache->statistics_OS as $row) {
             $counts += $row['stat_value'];
	}
    $image = file_exists("themes/".$ThemeSel."/images/lineBar.gif")? "themes/".$ThemeSel."/images/lineBar.gif" : "modules/Statistics/images/bar4.gif";

    $t = new table('pars_table', null, null, 5);
    $t->tr();
    $t->th( "شماره", "width: 50px" );
    $t->th( "نام سيستم عامل", "width: 200px" );
    $t->th( "نمودار" );
    $t->th( "تعداد", "width: 100px" );

    $i =1;
	foreach ($cache->statistics_OS as $row) {
             $count = round(100 * $row['stat_value'] / $counts);
             if ($count==0) $count = '0.5';
             $t->tr("class=".odd_even());
             $t->td( Convertnumber2farsi($i), "text-align: center" );
             $t->td( str_replace('OS-', '', $row['stat_name']), "text-align: left" );
             $t->td( '<div style="background: url('.$image.'); height: 11px; width: '.$count.'%"></div>' );
             $t->td( Convertnumber2farsi($row['stat_value']), "text-align: center" );
             $i++;
	}

    $t->show();
	closeTable();
	get_footer();
}

function Stats_Year() {
	global $db, $startdate, $cache, $ThemeSel;
    set_title("بازديدهاي ساليانه");
	get_header();
    Stats_Menu();
	openTable();
    if (!isset($cache->statistics_Year) || !is_array($cache->statistics_Year) || !count($cache->statistics_Year)) {
          $cache->statistics_Year = array();
          $result = $db->query("SELECT * from #__statistics WHERE stat_name LIKE '%Year-%' order by stat_name desc");
          while ($row = $db->fetchRow($result)) {
                 $cache->statistics_Year[ $row["stat_name"] ] = $row;
          }
          $db->freeResult($result);
          unset($result, $row);
    }
    if (!count($cache->statistics_Year)) pn_redirect('modules.php?name=Statistics');
    $counts = 0;
	foreach ($cache->statistics_Year as $row) {
             $counts += $row['stat_value'];
	}
    $image = file_exists("themes/".$ThemeSel."/images/lineBar.gif")? "themes/".$ThemeSel."/images/lineBar.gif" : "modules/Statistics/images/bar4.gif";

    $t = new table('pars_table', null, null, 5);
    $t->tr();
    $t->th( "شماره", "width: 50px" );
    $t->th( "سال", "width: 100px" );
    $t->th( "نمودار" );
    $t->th( "تعداد", "width: 100px" );
    $t->th( "آمار ماهيانه", "width: 80px" );

    $i =1;
	foreach ($cache->statistics_Year as $row) {
             $count = round(100 * $row['stat_value'] / $counts);
             if ($count==0) $count = '0.5';
             $t->tr("class=".odd_even());
             $t->td( Convertnumber2farsi($i), "text-align: center" );
             $t->td( Convertnumber2farsi((int) str_replace('Year-', '', $row['stat_name'])), "text-align: center" );
             $t->td( '<div style="background: url('.$image.'); height: 11px; width: '.$count.'%"></div>' );
             $t->td( Convertnumber2farsi($row['stat_value']), "text-align: center" );
             $t->td( html::a("modules.php?name=Statistics&amp;op=Month&amp;Year=".intval(str_replace('Year-', '', $row['stat_name'])), html::img("images/icon/calendar_view_day.png"), 'title="مشاهده آمار ماهيانه سال '.intval(str_replace('Year-', '', $row['stat_name'])).'"'), "text-align: center" );
             $i++;
	}

    $t->show();
	closeTable();
	get_footer();
}

function Stats_Month() {
	global $db, $pars, $cache, $ThemeSel;
    if (!is_numeric($pars->input['Year']) || $pars->input['Year']>jdate('Y') || strlen($pars->input['Year'])<4 || strlen($pars->input['Year'])>4) pn_redirect('modules.php?name=Statistics');
    set_title("آمار ماهيانه سال ".$pars->input['Year']);
	get_header();
    Stats_Menu();
	openTable();
    if (!isset($cache->statistics_Month) || !is_array($cache->statistics_Month) || !count($cache->statistics_Month)) {
          $LIKE = 'Month-'.$pars->input['Year'].'-';
          $cache->statistics_Month = array();
          $result = $db->query("SELECT * from #__statistics WHERE stat_name LIKE '%{$LIKE}%' order by stat_name asc");
          while ($row = $db->fetchRow($result)) {
                 $cache->statistics_Month[ $row["stat_name"] ] = $row;
          }
          $db->freeResult($result);
          unset($result, $row);
    }
    if (!count($cache->statistics_Month)) pn_redirect('modules.php?name=Statistics');
    $counts = 0;
	foreach ($cache->statistics_Month as $row) {
             $counts += $row['stat_value'];
	}
    $image = file_exists("themes/".$ThemeSel."/images/lineBar.gif")? "themes/".$ThemeSel."/images/lineBar.gif" : "modules/Statistics/images/bar4.gif";

    $t = new table('pars_table', null, null, 5);
    $t->tr();
    $t->th( "شماره", "width: 50px" );
    $t->th( "ماه", "width: 140px" );
    $t->th( "نمودار" );
    $t->th( "تعداد", "width: 100px" );
    $t->th( "آمار روزانه", "width: 80px" );

    $i =1;
	foreach ($cache->statistics_Month as $row) {
             $count = round(100 * $row['stat_value'] / $counts);
             $month = str_replace('Month-', '', $row['stat_name']);
             $month = explode('-', $month);
             if ($count==0) $count = '0.5';
             $t->tr("class=".odd_even());
             $t->td( Convertnumber2farsi($i), "text-align: center" );
             $t->td( short_monthname($month[1]).' ماه سال '.Convertnumber2farsi($month[0]), "text-align: center" );
             $t->td( '<div style="background: url('.$image.'); height: 11px; width: '.$count.'%"></div>' );
             $t->td( Convertnumber2farsi($row['stat_value']), "text-align: center" );
             $t->td( html::a("modules.php?name=Statistics&amp;op=Day&amp;Year=".$month[0]."&amp;Month=".$month[1], html::img("images/icon/calendar_view_day.png"), 'title="مشاهده آمار روزانه '.short_monthname($month[1]).' ماه سال '.Convertnumber2farsi($month[0]).'"'), "text-align: center" );
             $i++;
	}

    $t->tr("class=".odd_even());
    $t->td( Convertnumber2farsi($i), "text-align: center" );
    $t->td( 'مجموع آمار بازديد سال '.Convertnumber2farsi($month[0]), "", 'colspan="2"' );
    $t->td( Convertnumber2farsi($counts), "text-align: center" );
    $t->td( '-', "text-align: center" );

    $t->show();
	closeTable();
	get_footer();
}

function Stats_Day() {
	global $db, $pars, $cache, $ThemeSel;
    if (!is_numeric($pars->input['Year']) || $pars->input['Year']>jdate('Y') || strlen($pars->input['Year'])<4 || strlen($pars->input['Year'])>4 || !is_numeric($pars->input['Month']) || $pars->input['Month']>12 || strlen($pars->input['Month'])<2 || strlen($pars->input['Month'])>2) pn_redirect('modules.php?name=Statistics');
    set_title("آمار روزانه ".short_monthname($pars->input['Month'])." ماه سال ".$pars->input['Year']);
	get_header();
    Stats_Menu();
	openTable();
    if (!isset($cache->statistics_Day) || !is_array($cache->statistics_Day) || !count($cache->statistics_Day)) {
          $LIKE = 'Day-'.$pars->input['Year'].'-'.$pars->input['Month'].'-';
          $cache->statistics_Day = array();
          $result = $db->query("SELECT * from #__statistics WHERE stat_name LIKE '%{$LIKE}%' order by stat_name asc");
          while ($row = $db->fetchRow($result)) {
                 $cache->statistics_Day[ $row["stat_name"] ] = $row;
          }
          $db->freeResult($result);
          unset($result, $row);
    }
    if (!count($cache->statistics_Day)) pn_redirect('modules.php?name=Statistics');
    $counts = 0;
	foreach ($cache->statistics_Day as $row) {
             $counts += $row['stat_value'];
	}
    $image = file_exists("themes/".$ThemeSel."/images/lineBar.gif")? "themes/".$ThemeSel."/images/lineBar.gif" : "modules/Statistics/images/bar4.gif";

    $t = new table('pars_table', null, null, 5);
    $t->tr();
    $t->th( "شماره", "width: 50px" );
    $t->th( "ماه", "width: 160px" );
    $t->th( "نمودار" );
    $t->th( "تعداد", "width: 100px" );

    $i =1;
	foreach ($cache->statistics_Day as $row) {
             $count = round(100 * $row['stat_value'] / $counts);
             $day = str_replace('Day-', '', $row['stat_name']);
             $day = explode('-', $day);
             if ($count==0) $count = '0.5';
             $t->tr("class=".odd_even());
             $t->td( Convertnumber2farsi($i), "text-align: center" );
             $t->td( 'روز '.Convertnumber2farsi($day[2]).' '.short_monthname($day[1]).' ماه سال '.Convertnumber2farsi($day[0]), "text-align: center" );
             $t->td( '<div style="background: url('.$image.'); height: 11px; width: '.$count.'%"></div>' );
             $t->td( Convertnumber2farsi($row['stat_value']), "text-align: center" );
             $i++;
	}

    $t->tr("class=".odd_even());
    $t->td( Convertnumber2farsi($i), "text-align: center" );
    $t->td( 'مجموع آمار بازديد '.short_monthname($day[1]).' ماه سال '.Convertnumber2farsi($day[0]), "", 'colspan="2"' );
    $t->td( Convertnumber2farsi($counts), "text-align: center" );

    $t->show();
	closeTable();
	get_footer();
}

switch($op) {

	case'OS':
	Stats_OS();
	break;

	case'Year':
	Stats_Year();
	break;

	case'Month':
	Stats_Month();
	break;

	case'Day':
	Stats_Day();
	break;

	case'Browser':
	default:
	Stats_Browser();
	break;

}

?>