<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: common.php 2012-02-13 16:55:21 (Iman92)$
 */

defined('PARSNUKE_SETUP') or die("You are not allowed to access this page directly!");


error_reporting( E_ALL );

header ("Cache-Control: no-cache, must-revalidate"); // HTTP/1.1
header ("Pragma: no-cache"); // HTTP/1.0

/**
* Utility function to return a value from a named array or a specified default
*/
define( "_MOS_NOTRIM", 0x0001 );
define( "_MOS_ALLOWHTML", 0x0002 );
function mosGetParam( &$arr, $name, $def=null, $mask=0 ) {
	$return = null;
	if (isset( $arr[$name] )) {
		if (is_string( $arr[$name] )) {
			if (!($mask&_MOS_NOTRIM)) {
				$arr[$name] = trim( $arr[$name] );
			}
			if (!($mask&_MOS_ALLOWHTML)) {
				$arr[$name] = strip_tags( $arr[$name] );
			}
			if (!get_magic_quotes_gpc()) {
				$arr[$name] = addslashes( $arr[$name] );
			}
		}
		return $arr[$name];
	} else {
		return $def;
	}
}

function makePass($add='!@#$%^&*()_+=-:;?~', $length="8") {
	$cons = "QWERTYUIOPASDFGHJKLZXCVBNMbcdfghjklmnpqrstvwxyz1234567890".$add;
	$vocs = "aeiou";
	for ($x=0; $x < $length; $x++) {
		mt_srand ((double) microtime() * 1000000);
		$con[$x] = substr($cons, mt_rand(0, strlen($cons)-1), 1);
		$voc[$x] = substr($vocs, mt_rand(0, strlen($vocs)-1), 1);
	}
	mt_srand((double)microtime()*1000000);
	$num1 = mt_rand(0, 9);
	$num2 = mt_rand(0, 9);
	$makepass = $con[0] . $voc[0] .$con[2] . $num1 . $num2 . $con[3] . $voc[3] . $con[4];
	return($makepass);
}

function get_php_setting($val) {
	$r =  (ini_get($val) == '1' ? 1 : 0);
	return $r ? 'ON' : 'OFF';
}

function writableCell( $folder ) {
	echo '<tr>';
	echo '<td class="item">' . $folder . '</td>';
	echo '<td align="left">';
	echo is_writable( "../$folder" ) ? '<b><font color="green">Writeable</font></b>' : '<b><font color="red">Unwriteable</font></b>' . '</td>';
	echo '</tr>';
}

// Custom preg-match function
function preg_check($expression, $value) {
	if (!is_array($value)) {
		return preg_match($expression, $value);
	} else {
		return false;
	}
}

function pn_safe($text, $type='showhtml', $space=false) {
       $text = trim($text);
       switch($type) {
       case'en':
       $pattern = "A-Za-z-_";
       break;

       case'fa':
       $pattern = "-اآبپتثجچحخدذرزژسشصضطظعغفقكکگلمنوهیي_";
       break;

       case'fa-num':
       $pattern = "0-9-اآبپتثجچحخدذرزژسشصضطظعغفقكکگلمنوهیي_";
       break;

       case'en-fa-num':
       $pattern = "A-Za-z-0-9-اآبپتثجچحخدذرزژسشصضطظعغفقكکگلمنوهیي_";
       break;

       case'en-num':
       $pattern = "A-Za-z-0-9-_";
       break;

       case'nohtml':
       case'_nohtml':
       if($type=='_nohtml')
  	   $text = html_entity_decode($text, ENT_QUOTES, 'UTF-8');
  	   $text = strip_tags($text);
       return $text;
       break;

       case'htmldecode':
  	   $text = html_entity_decode($text, ENT_QUOTES, 'UTF-8');
       return $text;
       break;

       default:
       case'showhtml':
   	   $text = htmlentities($text, ENT_QUOTES, 'UTF-8');
	   $text = str_replace(array("<",">","'","\"","&amp;"),array("&lt;","&gt;","&#39;","&quot;","&"),$text);
       return $text;
       break;
       }
       if($space) $pattern = $pattern.' ';
       $text = preg_replace("([^$pattern]*)",'',$text);
       return $text;
}

/**
 * Validates the format of an email address.
 *
 * @param string The string to check.
 * @return boolean True when valid, false when invalid.
 */
function validate_email_format($email)
{
    if (phpversion() >= '5.2.0') {
        return filter_var($email, FILTER_VALIDATE_EMAIL);
    } else {
		if(strpos($email, ' ') !== false)
		{
			return false;
		}
		// Valid local characters for email addresses: http://www.remote.org/jochen/mail/info/chars.html
		return preg_match("/^[a-zA-Z0-9&*+\-_.{}~^\?=\/]+@[a-zA-Z0-9-]+\.([a-zA-Z0-9-]+\.)*[a-zA-Z0-9-]{2,}$/si", $email);
    }
}

function ValidateUrl($url){
    if (phpversion() >= '5.2.0') {
        return filter_var($url, FILTER_VALIDATE_URL);
    } else {
        return preg_match('/^(http(s?)://|ftp://{1})((w+.){1,})w{2,}$/i', $url);
    }
}

function get_ip() {
	if (!empty($_SERVER['HTTP_CLIENT_IP']))   //check ip from share internet
	{
		$ip=$_SERVER['HTTP_CLIENT_IP'];
	}
	elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR']))   //to check ip is pass from proxy
	{
		$ip=$_SERVER['HTTP_X_FORWARDED_FOR'];
	}
	else
	{
		$ip=$_SERVER['REMOTE_ADDR'];
	}
	$ip = pn_safe($ip, "_nohtml");
	return $ip;
}

?>