<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: setup-2.php 2012-02-13 16:55:21 (Iman92)$
 */

defined('PARSNUKE_SETUP') or die("You are not allowed to access this page directly!");

require_once("../configuration.php");
require_once("../includes/class_mysql.php");
$database = new sql_db($dbhost, $dbuname, $dbpass, $dbname, $prefix, false);

// delete existing mos table if exists
$query = "SHOW TABLES FROM `$dbname`";
if ($tables = $database->fetchRowSet($query, true)) {
		foreach ($tables as $table) {
				$query = "DROP TABLE IF EXISTS `{$table['Tables_in_'.$dbname]}`";
				$database->query( $query );
		}
}
populate_db($database, 'Pars-Nuke.sql' );

/**
 * @param object
 * @param string File name
 */
function populate_db( &$database, $sqlfile='Pars-Nuke.sql') {
	global $errors;

	$mqr = @get_magic_quotes_runtime();
	@set_magic_quotes_runtime(0);
	$query = fread( fopen( 'sql/' . $sqlfile, 'r' ), filesize( 'sql/' . $sqlfile ) );
	@set_magic_quotes_runtime($mqr);
	$pieces = split_sql($query);

	for ($i=0; $i<count($pieces); $i++) {
		$pieces[$i] = trim($pieces[$i]);
		if(!empty($pieces[$i]) && $pieces[$i] != "#") {
			$query = $database->query($pieces[$i], true);
			if (!$query) {
				$errors[] = array ( $database->error_string(), $pieces[$i] );
			}
		}
	}
}

/**
 * @param string
 */
function split_sql($sql) {
	$sql = trim($sql);
	$sql = @ereg_replace("\n#[^\n]*\n", "\n", $sql);

	$buffer = array();
	$ret = array();
	$in_string = false;

	for($i=0; $i<strlen($sql)-1; $i++) {
		if($sql[$i] == ";" && !$in_string) {
			$ret[] = substr($sql, 0, $i);
			$sql = substr($sql, $i + 1);
			$i = 0;
		}

		if($in_string && ($sql[$i] == $in_string) && $buffer[1] != "\\") {
			$in_string = false;
		}
		elseif(!$in_string && ($sql[$i] == '"' || $sql[$i] == "'") && (!isset($buffer[0]) || $buffer[0] != "\\")) {
			$in_string = $sql[$i];
		}
		if(isset($buffer[1])) {
			$buffer[0] = $buffer[1];
		}
		$buffer[1] = $sql[$i];
	}

	if(!empty($sql)) {
		$ret[] = $sql;
	}
	return($ret);
}

$isErr = intval( count( $errors ) );
?>
			<div class="far-left">
				<input class="button" type="submit" name="next" value="ادامه >>" onclick="setup_page('3');" />
  			</div>
	  		<div id="step">
	  			مرحله 2
	  		</div>
  			<div class="clr"></div>
  			<h1>ساختن جدول هاي ديتابيس</h1>
	  		<div style="text-align: right">
<?php
			if ($isErr) {
				echo "<font color='red'>Error log:</font><br />\n";
				// abrupt failure
				echo '<textarea rows="10" cols="50">';
				foreach($errors as $error) {
					echo "SQL=$error[0]:\n- - - - - - - - - -\n$error[1]\n= = = = = = = = = =\n\n";
				}
				echo '</textarea>';
				echo "\n";
  			} else {
  			    echo '<font color="green">تبريك جدول هاي ديتابيس با موفقيت ساخته شد.</font><br>';
  			    echo '<b>ليست جداول ساخته شده:</b><br>';
  			    $query = "SHOW TABLES FROM `$dbname`";
  			    $database->query( $query );
  			    if ($tables = $database->fetchRowSet($query, true)) {
  			    		foreach ($tables as $table) {
  			    				echo $table['Tables_in_'.$dbname]."<br>\n";
  			    		}
  			    }

  			}
?>
	  		</div>
