<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: setup-check.php 2012-02-13 16:55:21 (Iman92)$
 */

defined('PARSNUKE_SETUP') or die("You are not allowed to access this page directly!");
?>
<div id="step">برسي قبل از نصب</div>

<div class="far-left">
	<input name="Button2" type="submit" class="button" value="ادامه >>" onclick="setup_page('license');" />
	<br/>
	<br/>
	<input type="button" class="button" value="برسي مجدد" onclick="setup_page('check');" />
</div>
<div class="clr"></div>

<h1>برسي قبل از نصب براي نگارش <?php echo $version_number; ?> پارس نيوك</h1>
<div class="install-text">
هر كدام از آيتم هاي اين بخش كه قرمز رنگ باشد بايد اقدامات لازم براي رفع مشكل آن انجام شود در غير اينصورت نصب پارس نيوك با مشكل مواحه خواهد شد.
<div class="ctr"></div>
</div>

<div class="install-form">
<div class="form-block">

<table class="content">
<tr>
	<td class="item">
	PHP version >= 4.3.0
	</td>
	<td align="left">
	<?php echo phpversion() < '4.3' ? '<b><font color="red">No</font></b>' : '<b><font color="green">Yes</font></b>';?>
	</td>
</tr>
<tr>
	<td>
	&nbsp; - zlib compression support
	</td>
	<td align="left">
	<?php echo extension_loaded('zlib') ? '<b><font color="green">Available</font></b>' : '<b><font color="red">Unavailable</font></b>';?>
	</td>
</tr>
<tr>
	<td>
	&nbsp; - GD graphics support
	</td>
	<td align="left">
	<?php echo extension_loaded('gd') ? '<b><font color="green">Available</font></b>' : '<b><font color="red">Unavailable</font></b>';?>
	</td>
</tr>
<tr>
	<td>
	&nbsp; - MySQL support
	</td>
	<td align="left">
	<?php echo function_exists( 'mysql_connect' ) ? '<b><font color="green">Available</font></b>' : '<b><font color="red">Unavailable</font></b>';?>
	</td>
</tr>
<tr>
	<td valign="top" class="item">
	configuration.php
	</td>
	<td align="left">
	<?php
	if (@file_exists('../configuration.php') &&  @is_writable( '../configuration.php' )){
		echo '<b><font color="green">Writeable</font></b>';
	} else if (is_writable( '..' )) {
		echo '<b><font color="green">Writeable</font></b>';
	} else {
		echo '<b><font color="red">Unwriteable</font></b><br /><span class="small">You can still continue the install as the configuration will be displayed at the end, just copy & paste this and upload.</span>';
	} ?>
	</td>
</tr>
</table>
</div>
</div>
<div class="clr"></div>

<h1>تنظيمات توصيه شده براي پارس نيوك</h1>
<div class="install-text">
توصيه مي شود تنظيمات مقابل براي سازگاري كامل با پارس نيوك بر روي PHP انجام شود.
<div class="ctr"></div>
</div>

<div class="install-form">
<div class="form-block">

<table class="content">
<tr>
	<td class="toggle">
	نوع
	</td>
	<td class="toggle">
	توصیه شده
	</td>
	<td class="toggle">
	فعلی
	</td>
</tr>
<?php
$php_recommended_settings = array(array ('Safe Mode','safe_mode','OFF'),
array ('Display Errors','display_errors','ON'),
array ('File Uploads','file_uploads','ON'),
array ('Magic Quotes GPC','magic_quotes_gpc','ON'),
array ('Magic Quotes Runtime','magic_quotes_runtime','OFF'),
array ('Register Globals','register_globals','OFF'),
array ('Output Buffering','output_buffering','OFF'),
array ('Session auto start','session.auto_start','OFF'),
);

foreach ($php_recommended_settings as $phprec) {
?>
<tr>
	<td class="item"><?php echo $phprec[0]; ?>:</td>
	<td class="toggle"><?php echo $phprec[2]; ?></td>
	<td>
	<?php
	if ( get_php_setting($phprec[1]) == $phprec[2] ) {
	?>
		<font color="green"><b>
	<?php
	} else {
	?>
		<font color="red"><b>
	<?php
	}
	echo get_php_setting($phprec[1]);
	?>
	</b></font>
	<td>
</tr>
<?php
}
?>
</table>
</div>
</div>
<div class="clr"></div>

<h1>دسترسي فايل ها</h1>
<div class="install-text">
پارس نيوك نياز دارد تا بتواند اين فايل ها و پوشه ها را ويرايش كند.
<div class="clr">&nbsp;&nbsp;</div>
<div class="ctr"></div>
</div>

<div class="install-form">
<div class="form-block">

<table class="content">
<?php
writableCell('configuration.php');
writableCell('ultramode.txt');
writableCell('robots.txt');
writableCell('includes/upload/');
writableCell('images/avatars/');
writableCell('includes/cache/');
?>
</table>
</div>
<div class="clr"></div>
</div>