<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: index.php 2012-02-13 16:55:21 (Iman92)$
 */

if(function_exists('date_default_timezone_set'))
date_default_timezone_set('Asia/Tehran');

Header("Content-type: text/html; charset=utf-8");
define('PARSNUKE_SETUP', 1);
define('IS_AJAX', (isset($_SERVER['HTTP_X_REQUESTED_WITH']) && strtolower($_SERVER['HTTP_X_REQUESTED_WITH']) == 'xmlhttprequest'));

/** Includes */
require_once('includes/version.php');
include_once('includes/common.php');

$op = mosGetParam($_GET, 'op', 'check');

if (file_exists("includes/setup-{$op}.php") && IS_AJAX && !file_exists("ParsNuke.lock")) {
    include_once("includes/setup-{$op}.php");
    die;
}

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>Pars-Nuke Installer</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<link rel="shortcut icon" href="../images/favicon.ico" />
<link rel="stylesheet" href="theme/install.css" type="text/css" />
<script type="text/javascript" src="http://ajax.googleapis.com/ajax/libs/jquery/1.4/jquery.min.js"></script>
<script>!window.jQuery && document.write('<script src="../includes/pars_nuke/javascript/jquery.js"><\/script>');</script>
<script language="JavaScript" type="text/javascript">
/*<![CDATA[*/
function setup_page(page) {
   jQuery(document).ready(function(){
        $('div#pn-ajax').html('<br /><br /><br /><center><img src="../images/loading/loader-7.gif" width="36" height="36" /></center>');
        $('div#pn-ajax').load('index.php?op='+page, function(){ $('div#stepbar div').removeClass('step-on'); $('div#stepbar div').addClass('step-off'); $('div#stepbar div#step-'+page).addClass('step-on') });
   });
   return false;
}
/*]]>*/
</script>
</head>
<body>
<div id="wrapper">
	<div id="header">
		<div id="phpnuke"><img src="theme/header_install.png" alt="Pars-Nuke Installation" /></div>
	</div>
</div>
<div id="ctr" align="center">
	<div class="install">
	<div id="stepbar">
		<div class="step-<?php echo $op=='check'? 'on' : 'off' ?>" id="step-check">برسي قبل از نصب</div>
		<div class="step-<?php echo $op=='license'? 'on' : 'off' ?>" id="step-license">ليسانس</div>
		<div class="step-<?php echo $op=='1'? 'on' : 'off' ?>" id="step-1">مرحله 1</div>
		<div class="step-<?php echo $op=='2'? 'on' : 'off' ?>" id="step-2">مرحله 2</div>
		<div class="step-<?php echo $op=='3'? 'on' : 'off' ?>" id="step-3">مرحله 3</div>
		<div class="step-<?php echo $op=='4'? 'on' : 'off' ?>" id="step-4">مرحله 4</div>
	</div>
	<div id="right">
	<div id="pn-ajax">
    <?php
    if (file_exists("includes/setup-{$op}.php") && !file_exists("ParsNuke.lock"))
    include_once("includes/setup-{$op}.php");
    elseif (file_exists("ParsNuke.lock"))
    echo "<br /><br /><font color=red>پارس نيوك قبلا نصب شده است!<br />براي نصب مجدد فايل <b>ParsNuke.lock</b> را از پوشه <b>setup</b> حذف كنيد.</font>";
    ?>
	</div>
	</div>
	<div id="break"></div>
	<div class="clr"></div>
	<div class="clr"></div>
	</div>
</div>
<div class="ctr" style="direction: ltr">
	<a href="http://Parsnuke.com" target="_blank">Pars-Nuke</a> is Free Software released under the GNU/GPL License.
</div>
</body>
</html>