<?PHP
/**
 * Pars-Nuke: Advanced Content Management System
 * Copyright 2012 Pars-Nuke Group, All Rights Reserved
 *
 * Website: http://parsnuke.com
 * License: http://www.gnu.org/licenses/
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Id: sitemap.php 2012-02-13 16:52:31 (Iman92)$
 */

function parsnuke_sitemap() {
	  global $prefix, $db, $pars, $cache, $debug, $firewall, $language, $currentlang;
      require_once("mainfile.php");
      $sitemap = array();
      $sitemap[] = array("loc"=>"", "lastmod"=>time(), "changefreq"=>"daily", "priority"=>"1.0");
      foreach ($cache->modules as $PN_module => $val)
      {
          if ($val['active']==0) continue;
          $sitemap[] = array("loc"=>"modules.php?name=".$PN_module, "lastmod"=>time(), "changefreq"=>"monthly", "priority"=>"0.9");
	   	  if(file_exists("modules/{$PN_module}/{$PN_module}.seo.php") && $pars->settings['seo']==1)
          {
      		  require("modules/{$PN_module}/{$PN_module}.seo.php");
	   	  };
      	  if(file_exists("modules/{$PN_module}/{$PN_module}.sitemap.php"))
          {
      		  require("modules/{$PN_module}/{$PN_module}.sitemap.php");
      	  };
      };
      unset($PN_module, $val);

      $xml  = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
      $xml .= "<?xml-stylesheet type=\"text/xsl\" href=\"includes/sitemap.xsl\"?>\n";
      $xml .= "<!-- generator=\"ParsNuke\" -->\n";
      $xml .= "<urlset xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\" xsi:schemaLocation=\"http://www.sitemaps.org/schemas/sitemap/0.9 http://www.sitemaps.org/schemas/sitemap/0.9/sitemap.xsd\" xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";
      if (is_array($sitemap) && count($sitemap))
      {
             foreach ($sitemap as $map)
             {
                   $xml .= "<url>\n";
                   $xml .= "	 <loc>".$map['loc']."</loc>\n";
                   $xml .= "	 <lastmod>".date("M j, Y", $map['lastmod'])."</lastmod>\n";
                   $xml .= "	 <changefreq>".$map['changefreq']."</changefreq>\n";
                   $xml .= "	 <priority>".$map['priority']."</priority>\n";
                   $xml .= "</url>\n";
             };
      };
      $xml .= "</urlset>";

      if (is_array($pars->urls) && count($pars->urls) && $pars->settings['seo']==1)
      {
             foreach ($pars->urls as $url => $seo)
             {
                   $url = pn_str_replace(array("'(?<!/)", "'"), null, $url);
                   $xml = preg_replace("#<loc>".trim($url)."<\/loc>#", "<loc>".trim($seo)."</loc>", $xml);
             };
      };
      $xml = pn_str_replace("<loc>", "<loc>".$pars->settings['siteurl']."/", $xml);

      @file_put_contents("includes/cache/sitemap.xml", $xml);
      echo $xml;
};

header("Content-type: application/xml; charset=utf-8");
if (file_exists("includes/cache/sitemap.xml") && is_writable("includes/cache/sitemap.xml")) {

      $cacheLife = 60*60*2;
      $cacheFileLife = filemtime("includes/cache/sitemap.xml");
      if ($cacheFileLife+$cacheLife > time()) {
            echo file_get_contents("includes/cache/sitemap.xml");
      } else {
            parsnuke_sitemap();
      };
      die;

};

parsnuke_sitemap();
?>